;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "cpctelera.h.s"
.include "main.h.s"
.include "sys/physics.h.s"
.include "man/entity.h.s"
.include "man/game.h.s"
.include "man/input.h.s"
.include "sys/render.h.s"
.include "man/animations.h.s"
.include "sys/generator.h.s"
.include "sys/ai.h.s"
.include "man/levels.h.s"
.include "sys/colision.h.s"
.include "music/music.h.s"
.include "man/int.h.s"
.include "man/menu.h.s"

.area _DATA
.area _CODE

;;////////////////////
;; Reservamos memoria
   game_state::
      .dw #0x0000
;;////////////////////

_main::
   call cpct_disableFirmware_asm

   ld sp, #0x8000
   ld hl, #man_menu_main_init
   ld (game_state), hl

   call sys_render_mem_init
   ; call man_game_menu
;; Bucle del juego
loop: 
   ;; //TODO CONTROLAR IF PRESS ESCAPE GO TO GAME_STATE = MAN_MAIN_MENU_INIT
   ;call man_int_init
   call cpct_scanKeyboard_asm
   ld hl, #Key_Esc
   call cpct_isKeyPressed_asm
   jr z, normal_loop
   ld hl, #man_menu_main_init
   ld (game_state), hl
   normal_loop:
      ld hl, #loop      ;; /
      push hl           ;; \ Guardamos en la pila el valor para que vuelva del metodo al que se llama

      ld hl, (game_state)
      jp (hl)

   jr loop


