;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "animations.h.s"
.include "sprites/assets.h.s"
.include "entity.h.s"

;;; ///////////////////////////////////////////
;;; MEMORY    
;;; ///////////////////////////////////////////

;;; ///////////////////////////////////////////
;;; Animations
    ;; Semifusa
        ;Left
            animation_semifusa_leftrun:
                .db SEMIFUSA_RUN_DURATION
                .dw _sp_semifusa_leftrun_1
                .db SEMIFUSA_RUN_DURATION
                .dw _sp_semifusa_leftrun_2
                .db SEMIFUSA_RUN_DURATION
                .dw _sp_semifusa_leftrun_1
                .db SEMIFUSA_RUN_DURATION
                .dw _sp_semifusa_left
                .db 0x00
                .dw animation_semifusa_leftrun 
        ;Right
            animation_semifusa_rightrun:
                .db SEMIFUSA_RUN_DURATION
                .dw _sp_semifusa_rightrun_1
                .db SEMIFUSA_RUN_DURATION
                .dw _sp_semifusa_rightrun_2
                .db SEMIFUSA_RUN_DURATION
                .dw _sp_semifusa_rightrun_1
                .db SEMIFUSA_RUN_DURATION
                .dw _sp_semifusa_right
                .db 0x00
                .dw animation_semifusa_rightrun 

    
    ;; Player
        animation_player_rightidle::
            .db 5
            .dw _sp_player_rightidle_1
            .db 5
            .dw _sp_player_right
            .db 0x00
            .dw animation_player_rightidle  

        animation_player_leftidle::
            .db 5
            .dw _sp_player_leftidle_1
            .db 5
            .dw _sp_player_left
            .db 0x00
            .dw animation_player_leftidle  

        animation_player_rightidle_aux:         ; Sirve para cambiar a esta despues del ataque para que todo vaya como debe ir
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_rightidle_1
            .db 5
            .dw _sp_player_right
            .db 0x00
            .dw animation_player_rightidle  

        animation_player_leftidle_aux:          ; Sirve para cambiar a esta despues del ataque para que todo vaya como debe ir
            .db ATTACK_FRAME_DURATION   
            .dw _sp_player_leftidle_1
            .db 5
            .dw _sp_player_left
            .db 0x00
            .dw animation_player_leftidle 

        animation_player_rightattack::
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_rightattack_1
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_rightattack_2
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_rightattack_3
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_rightattack_4
            .db 0x00
            .dw animation_player_rightidle_aux     
    
        animation_player_rightattack_infinite::
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_player_rightattack_1
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_player_rightattack_2
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_player_rightattack_3
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_player_rightattack_4
            .db 0x00
            .dw animation_player_rightattack_infinite     


        animation_player_leftattack::
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_leftattack_1
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_leftattack_2
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_leftattack_3
            .db ATTACK_FRAME_DURATION
            .dw _sp_player_leftattack_4
            .db 0x00
            .dw animation_player_leftidle_aux   

        animation_player_leftattack_infinite::
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_player_leftattack_1
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_player_leftattack_2
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_player_leftattack_3
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_player_leftattack_4
            .db 0x00
            .dw animation_player_leftattack_infinite  
 
        animation_sword_rightattack::
            .db ATTACK_FRAME_DURATION
            .dw _sp_sword_rightattack_1
            .db ATTACK_FRAME_DURATION
            .dw _sp_sword_attack_vacuum
            .db ATTACK_FRAME_DURATION
            .dw _sp_sword_rightattack_3
            .db ATTACK_FRAME_DURATION
            .dw _sp_sword_rightattack_4
            .db 0x00
            .dw animation_sword_vacuum


        animation_sword_rightattack_infinite::
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_sword_rightattack_1
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_sword_attack_vacuum
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_sword_rightattack_3
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_sword_rightattack_4
            .db 0x00
            .dw animation_sword_rightattack_infinite

         animation_sword_leftattack::
            .db ATTACK_FRAME_DURATION
            .dw _sp_sword_leftattack_1
            .db ATTACK_FRAME_DURATION
            .dw _sp_sword_attack_vacuum
            .db ATTACK_FRAME_DURATION
            .dw _sp_sword_leftattack_3
            .db ATTACK_FRAME_DURATION
            .dw _sp_sword_leftattack_4
            .db 0x00
            .dw animation_sword_vacuum


        animation_sword_leftattack_infinite::
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_sword_leftattack_1
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_sword_attack_vacuum
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_sword_leftattack_3
            .db INFINITE_ATTACK_FRAME_DURATION
            .dw _sp_sword_leftattack_4
            .db 0x00
            .dw animation_sword_leftattack_infinite

         animation_sword_vacuum::
            .db ATTACK_FRAME_DURATION       ;Para que cambie automaticamente 
            .dw _sp_sword_attack_vacuum
            .db 255                         ;Para que tarde lo maximo posible en hacer los calculos de la animacion
            .dw _sp_sword_attack_vacuum
            .db 0x00
            .dw animation_sword_vacuum 

        animation_player_death::
            .db DEATH_DURATION                      
            .dw _sp_player_death_2
            .db DEATH_DURATION              
            .dw _sp_player_death_3
            .db 0x00
            .dw animation_player_dead

        animation_player_dead:
            .db DEATH_DURATION                         
            .dw _sp_player_death_3
            .db 0x00
            .dw animation_player_dead

    ;; Blanca
        ;Izquierda
            animation_blanca_leftrun:
                .db BLANCA_RUN_DURATION       
                .dw _sp_blanca_leftrun_1
                .db BLANCA_RUN_DURATION       
                .dw _sp_blanca_left
                .db 0x00
                .dw animation_blanca_leftrun

            animation_blanca_leftdig:
                .db BLANCA_DIG_DURATION       
                .dw _sp_blanca_leftdig_1
                .db BLANCA_DIG_DURATION       
                .dw _sp_blanca_leftdig_2
                .db 0x00
                .dw animation_blanca_leftunderground
            
            animation_blanca_leftunderground:
                .db BLANCA_UNDERGROUND_DURATION       
                .dw _sp_blanca_leftdown_1
                .db BLANCA_UNDERGROUND_DURATION       
                .dw _sp_blanca_leftdown_2
                .db 0x00
                .dw animation_blanca_leftunderground

            animation_blanca_leftdigout:
                .db BLANCA_DIGOUT_DURATION        
                .dw _sp_blanca_leftdig_2
                .db BLANCA_UNDERGROUND_DURATION       
                .dw _sp_blanca_leftdig_1
                .db 0x00
                .dw animation_blanca_leftrun

        ;Derecha
            animation_blanca_rightrun:
                .db BLANCA_RUN_DURATION       ;Para que cambie automaticamente 
                .dw _sp_blanca_rightrun_1
                .db BLANCA_RUN_DURATION       ;Para que tarde lo maximo posible en hacer los calculos de la animacion
                .dw _sp_blanca_right
                .db 0x00
                .dw animation_blanca_rightrun

            animation_blanca_rightdig:
                .db BLANCA_DIG_DURATION       ;Para que cambie automaticamente 
                .dw _sp_blanca_rightdig_1
                .db BLANCA_DIG_DURATION       ;Para que cambie automaticamente 
                .dw _sp_blanca_rightdig_2
                .db 0x00
                .dw animation_blanca_rightunderground
            
            animation_blanca_rightunderground:
                .db BLANCA_UNDERGROUND_DURATION       ;Para que cambie automaticamente 
                .dw _sp_blanca_rightdown_1
                .db BLANCA_UNDERGROUND_DURATION       ;Para que cambie automaticamente 
                .dw _sp_blanca_rightdown_2
                .db 0x00
                .dw animation_blanca_rightunderground

            animation_blanca_rightdigout:
                .db BLANCA_DIGOUT_DURATION       ;Para que cambie automaticamente 
                .dw _sp_blanca_rightdig_2
                .db BLANCA_UNDERGROUND_DURATION       ;Para que cambie automaticamente 
                .dw _sp_blanca_rightdig_1
                .db 0x00
                .dw animation_blanca_rightrun

    ;; Negra
        ;Izquierda
            animation_negra_leftrun:
                .db NEGRA_RUN_DURATION       
                .dw _sp_negra_leftrun_1
                .db NEGRA_RUN_DURATION       
                .dw _sp_negra_left
                .db 0x00
                .dw animation_negra_leftrun

        ;Derecha 
            animation_negra_rightrun:
                .db NEGRA_RUN_DURATION       
                .dw _sp_negra_rightrun_1
                .db NEGRA_RUN_DURATION       
                .dw _sp_negra_right
                .db 0x00
                .dw animation_negra_rightrun
            

    ;; Redonda
        animation_redonda_left:
            .db REDONDA_DURATION       
            .dw _sp_redonda_back
            .db REDONDA_DURATION       
            .dw _sp_redonda_right
            .db REDONDA_DURATION       
            .dw _sp_redonda_front
            .db REDONDA_DURATION       
            .dw _sp_redonda_left
            .db 0x00
            .dw animation_redonda_left

        animation_redonda_right:
            .db REDONDA_DURATION       
            .dw _sp_redonda_back
            .db REDONDA_DURATION       
            .dw _sp_redonda_left
            .db REDONDA_DURATION       
            .dw _sp_redonda_front
            .db REDONDA_DURATION       
            .dw _sp_redonda_right
            .db 0x00
            .dw animation_redonda_right
            
    ;; Spirit
            animation_spirit:
                .db 1      
                .dw _sp_spirit_1
                .db SPIRIT_DURATION       
                .dw _sp_spirit_2
                .db SPIRIT_DURATION       
                .dw _sp_spirit_3
                .db SPIRIT_DURATION       
                .dw _sp_spirit_4
                .db SPIRIT_DURATION       
                .dw _sp_spirit_3
                .db SPIRIT_DURATION       
                .dw _sp_spirit_2   
                .db 0x00
                .dw animation_spirit

            animation_card:
                .db CARD_DURATION
                .dw _sp_card_right
                .db CARD_DURATION
                .dw _sp_card_bottom
                .db CARD_DURATION
                .dw _sp_card_left
                .db CARD_DURATION
                .dw _sp_card_top
                .db 0x00
                .dw animation_card

;;; ///////////////////////////////////////////

;MAN_ANIMATION_UPDATE_ONE_ENTITY
    ;Actualiza el sprite de una entidad
    ;Inputs: IY -> Posicion de memoria de la entidad
    ;Destrois: A, HL, BC, DE   
    man_animation_update_one_entity:
        ld a, ent_frame(iy) ;/
        inc a               ;| frame_actual++
        ld ent_frame(iy), a ;\
        ;;;if(frame_actual != frames_totales){
            ld l, ent_animation_mayor(iy)   ;/
            ld h, ent_animation_menor(iy)   ;\ HL = Direccion de memoria del paso actual de la animacion
            cp (hl)                         ;Resta logica de los frames que tiene la animacion y los que lleva contados la entidad
            jr nz, end_if_ultimo_frame              
            ;;;@(frame_actual == frames_totales)
                xor a                               ;/
                ld  ent_frame(iy), a                ;\ Reseteamos el contador de frames de la entidad

                inc hl                              ;HL = Posicion de memoria del primer byte nuevo sprite
                ld  d, (hl)                         ;/ D = Primer byte de la posicion del proximo sprite
                inc hl                              ;|            
                ld  e, (hl)                         ;| E = Segundo byte de la posicion del proximo sprite
                ld  ent_sprite_mayor(iy), d         ;|     
                ld  ent_sprite_menor(iy), e         ;\ Entidad.sprite = Posicion de memoria del nuevo sprite

                inc hl                              ;Hl apunta al inicio del proximo paso de la animacion
                ld  ent_animation_menor(iy), h      ;/
                ld  ent_animation_mayor(iy), l      ;\ Entidad.animation = Posicion de memoria del proximo paso de la animacion  
                
                ;;;EXPLICACION SIGUIENTE IF
                    ;Despues de cambiar el sprite al correspondiente y el puntero a la animacion 
                    ;al paso de la animacion correspondiente, hay que comprobar si la cantidad
                    ;de frames del paso de la animacion al que se esta apuntando ahora es 0.
                    ;En ese caso tenemos que volver al inicio de la animacion (poner el puntero
                    ;a animacion de la entidad de nuevo al primer paso)
                ;;;

                ;;;if(frames_totales == 0){
                    ld a, (hl)                      ; A = Duracion (en frames) del paso proximo de la animacion
                    or a
                    ret nz                          ; Si A no es 0 hacemos un return
                    ;;;@(frames_totales == 0)
                        inc hl                          ;HL = Posicion de memoria del primer byte de la animacion a la que saltar
                        ld d, (hl)                      ;D =  Primer byte de la animacion a la que saltar   
                        ld ent_animation_mayor(iy), d   ;Entidad.animation1b = Primer byte de la animacion a la que saltar
                        inc hl                          ;HL = Posicion de memoria del segundo byte de la animacion a la que saltar
                        ld e, (hl)                      ;E = Segundo byte de la animacion a la que saltar
                        ld ent_animation_menor(iy), e   ;Entidad.animation2b = Segundo byte de la animacion a la que saltar
                    ;;;
                ;;;}
            ;;;                         
            end_if_ultimo_frame:
        ;;;}
    ret
;/////////////////

;MAN_ANIMATION_UPDATE_ONE_ENTITY
    ;Actualiza el sprite de todas las entidades animables
    ;Destrois:  
    man_animation_update::
        ld a,  #ENT_TYPE_ANIMATION
        ld hl, #man_animation_update_one_entity
        call man_entity_forall_mask
    ret
;/////////////////

