.include "sprites/assets.h.s"
.include "man/animations.h.s"
;;; ///////////////////////////////////////////
;;; Symbols

    ENTITY_SIZE = 26
    NUM_ENTITIES = 20


    ENT_X_RIGHT_DEFAULT = 80
    ENT_X_LEFT_DEFAULT = 00
    ENT_Y_DEFAULT = 120
    ENT_ENEMY_DEFAULT_SPEED = 1

    ;;Simbolos del espiritu de muerte
        ENT_SPIRIT_SPEED_Y  = 1
        ENT_SPIRIT_WIDTH    = SP_SPIRIT_W
        ENT_SPIRIT_HEIGHT   = SP_SPIRIT_H
        ENT_SPIRIT_ANIMATION_DURATION = SPIRIT_DURATION*6
    ;;///////////////
    
    ENT_RELATIVE_Y = 165

    ;;Simbolos de la entidad: negra
        ENT_NEGRA_X_RELATIVE = 80
        ENT_NEGRA_X          = ENT_X_RIGHT_DEFAULT - SP_NEGRA_W
        ENT_NEGRA_Y_RELATIVE = ENT_RELATIVE_Y
        ENT_NEGRA_Y          = ENT_NEGRA_Y_RELATIVE - SP_NEGRA_H
        ENT_NEGRA_SCORE      = 0x5
    ;;///////////////

    ;;Simbolos de la entidad: semifusa
        ENT_SEMIFUSA_X_RELATIVE = 80
        ENT_SEMIFUSA_X          = ENT_X_RIGHT_DEFAULT - SP_SEMIFUSA_W
        ENT_SEMIFUSA_Y_RELATIVE = ENT_RELATIVE_Y
        ENT_SEMIFUSA_Y          = ENT_SEMIFUSA_Y_RELATIVE - SP_SEMIFUSA_H
        ENT_SEMIFUSA_SCORE      = 0x20
    ;;///////////////

    ;;Simbolos de la entidad: blanca
        ENT_BLANCA_X_RELATIVE = 80
        ENT_BLANCA_X          = ENT_X_RIGHT_DEFAULT - SP_BLANCA_W
        ENT_BLANCA_Y_RELATIVE = ENT_RELATIVE_Y
        ENT_BLANCA_Y          = ENT_BLANCA_Y_RELATIVE - SP_BLANCA_H
        ENT_BLANCA_SCORE      = 0x15
    ;;///////////////

    ;;Simbolos de la entidad: redonda
        ENT_REDONDA_X_RELATIVE = 80
        ENT_REDONDA_X          = ENT_X_RIGHT_DEFAULT - SP_REDONDA_W
        ENT_REDONDA_Y_RELATIVE = ENT_RELATIVE_Y + 10
        ENT_REDONDA_Y          = ENT_REDONDA_Y_RELATIVE - SP_REDONDA_H
        ENT_REDONDA_SCORE      = 0x10
    ;;///////////////

    ;;Simbolos de la entidad: jugador muerto
        ENT_PLAYER_DEATH_HEIGHT             = SP_PLAYER_DEATH_H
        ENT_PLAYER_DEATH_WIDTH              = SP_PLAYER_DEATH_W
        ENT_PLAYER_DEATH_RELATIVE_Y         = ENT_RELATIVE_Y
        ENT_PLAYER_DEATH_Y                  = ENT_PLAYER_DEATH_RELATIVE_Y - ENT_PLAYER_DEATH_HEIGHT
    ;;///////////////

    ;;Simbolos de la entidad: jugador
        ENT_PLAYER_HEIGHT       = SP_PLAYER_H
        ENT_PLAYER_WIDTH        = SP_PLAYER_W
        ENT_PLAYER_RELATIVE_X   = 39
        ENT_PLAYER_X            = ENT_PLAYER_RELATIVE_X - (ENT_PLAYER_WIDTH/2)
        ENT_PLAYER_RELATIVE_Y   = ENT_RELATIVE_Y
        ENT_PLAYER_Y            = ENT_PLAYER_RELATIVE_Y - ENT_PLAYER_HEIGHT
        ENT_THRESHOLD_DURATION  = 15
        ENT_PLAYER_MEM          = (0*ENTITY_SIZE) ;; Posicion en el array del player
        ENT_PLAYER_LEFT_ATACK   = (1*ENTITY_SIZE) ;; Posicion en el array del ataque izquierdo
        ENT_PLAYER_RIGHT_ATACK  = (2*ENTITY_SIZE) ;; Posicion en el array del ataque derecho
        ENT_THRESHOLD           = (3*ENTITY_SIZE) ;; Posicion en el array de la etiqueta de umbral
    ;;///////////////

    ;;Simbolos de la entidad: ataque
        ENT_ATACK_HEIGHT            = SP_ATACK_H
        ENT_ATACK_WIDTH             = SP_ATACK_W
        ENT_ATACK_RELATIVE_X        = 0
        ENT_ATACK_X_LEFT            = ENT_PLAYER_X - ENT_ATACK_WIDTH - ENT_ATACK_RELATIVE_X
        ENT_ATACK_X_RIGHT           = ENT_PLAYER_X + ENT_PLAYER_WIDTH + ENT_ATACK_RELATIVE_X
        ENT_ATACK_RELATIVE_Y        = 11
        ENT_ATACK_Y                 = ENT_PLAYER_Y + ENT_ATACK_RELATIVE_Y
    ;;///////////////

    ;;Simbolos de la entidad: threshold
        ENT_THRESHOLD_HEIGHT        = SP_PRECISION_LABEL_H
        ENT_THRESHOLD_WIDTH         = SP_PRECISION_LABEL_W
        ENT_THRESHOLD_X             = ENT_PLAYER_X + (ENT_PLAYER_WIDTH/2) - (ENT_THRESHOLD_WIDTH/2) ;; Ambos centros del eje X del umbral y del player coinciden
        ENT_THRESHOLD_RELATIVE_Y    = -10         ;; Distancia del jugador a la etiqueta de umbral
        ENT_THRESHOLD_Y             = ENT_PLAYER_Y - ENT_THRESHOLD_HEIGHT - ENT_THRESHOLD_RELATIVE_Y
    ;/////////////////

    ;;Simbolos referentes a la IA
        AI_MARGIN_RIGHT                      = ENT_PLAYER_RELATIVE_X + (ENT_PLAYER_WIDTH/2) +1 
        AI_MARGIN_SEMIFUSA_LEFT              = ENT_PLAYER_RELATIVE_X - (ENT_PLAYER_WIDTH/2) - SP_SEMIFUSA_W +1
        AI_MARGIN_BLANCA_LEFT                = ENT_ATACK_X_LEFT - SP_BLANCA_W 
        AI_MARGIN_BLANCA_RIGHT               = ENT_ATACK_X_RIGHT + SP_BLANCA_W   
    ;;///////////////

    ;;Simbolos del tipo de la entidad
        ENT_TYPE_ORIENTATION    = 0x01        ;; 0000 0001 -> Orientacion (miran hacia: 1 izq, 0 drch)
        ENT_TYPE_COLISION       = 0x02        ;; 0000 0010 -> Colisionable
        ENT_TYPE_PHYSICS        = 0x04        ;; 0000 0100 -> Tiene fisicas
        ENT_TYPE_RENDER         = 0x08        ;; 0000 1000 -> Renderizable
        ENT_TYPE_ANIMATION      = 0x10        ;; 0001 0000 -> Animable  
        ENT_TYPE_AI             = 0x20        ;; 0010 0000 -> Tiene IA 
        ENT_TYPE_ATACKING       = 0x40        ;; 0100 0000 -> Atacando (exclusivo jugador)
        ENT_TYPE_CONDEMNED      = 0x80        ;; 1000 0000 -> Condenado
    ;;///////////////
    
    ;-ENTITY VALUES-
        ;--Manager--
            ent_type = 0
        ;--Physics--
            ent_x = 1
            ent_y = 2
            ent_vx = 3
        ;--Render--
            ent_height                          = 4
            ent_width                           = 5
            ent_sprite_mayor                    = 6
            ent_sprite_menor                    = 7
            ent_last_sprite_mayor               = 8
            ent_last_sprite_menor               = 9
            ent_last_memory_position_mayor      = 10
            ent_last_memory_position_menor      = 11
            ent_last_sprite_mayor_2             = 12
            ent_last_sprite_menor_2             = 13
            ent_last_memory_position_mayor_2    = 14
            ent_last_memory_position_menor_2    = 15
            ent_render_function_mayor           = 16
            ent_render_function_menor           = 17
        ;--Animations--
            ent_animation_mayor = 18
            ent_animation_menor = 19
            ent_frame           = 20
        ;--IA--
            ent_behavior_mayor = 21
            ent_behavior_menor = 22
            ent_ia_status      = 23 
            ent_contador       = 24  
            ent_ia_score       = 25
    ;-END ENTITY VALUES-
    
    ;;;Entity AI-status enum
            ent_ai_st_down       = 0
            ent_ai_st_up         = 1
            ent_ai_st_move_to    = 2
            ent_ai_st_condemn    = 3

    next_ent_type = ent_type + ENTITY_SIZE
    nullptr = 0x0000
;;; ///////////////////////////////////////////

;;; ///////////////////////////////////////////
;;; Global
    .globl cpct_memset_asm    

    ;; Funcionalidades
        .globl man_entity_init
        .globl man_entity_create_with_template
        .globl man_entity_prepare_to_condemn
        .globl man_entity_condemn
        .globl man_entity_delete
        .globl man_entity_update
        .globl man_entity_forall
        .globl man_entity_forall_mask
        .globl man_entity_forall_precise
        .globl man_entity_get_player
        .globl man_entity_add_type
        .globl man_entity_remove_type
        .globl man_entity_threshold_update
        .globl man_entity_enemies_left
    ;; ////////////////

    ;; Templates
        .globl man_entity_semifusa
        .globl man_entity_blanca
        .globl man_entity_negra
        .globl man_entity_redonda
        .globl man_entity_player
        .globl man_entity_atack_right
        .globl man_entity_atack_left
        .globl man_entity_spirit
        .globl man_entity_threshold
    ;; //////////
;;; ///////////////////////////////////////////