;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "cpctelera.h.s"
.include "entity.h.s"
.include "../sprites/assets.h.s"
.include "sys/generator.h.s"
.include "animations.h.s"
.include "sys/ai.h.s"
.include "sys/render.h.s"
.include "man/int.h.s"



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PLANTILLAS DE ENTIDADES
    ;ENTITY_NEGRA
        ;Plantilla para entidad: enemigo > negra
        man_entity_negra::
            .db #(ENT_TYPE_RENDER | ENT_TYPE_PHYSICS | ENT_TYPE_ANIMATION | ENT_TYPE_AI | ENT_TYPE_COLISION | ENT_TYPE_ORIENTATION)    ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #ENT_NEGRA_X                                ;; POSITION_X
            .db #ENT_NEGRA_Y                                ;; POSITION_Y
            .db #ENT_ENEMY_DEFAULT_SPEED                                          ;; SPEED_X
            .db #SP_NEGRA_H                                 ;; HEIGHT      --> alto de la entidad
            .db #SP_NEGRA_W                                 ;; WIDTH       --> ancho de la entidad
            .dw #_sp_negra_left                             ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                     ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado
            .dw #0x0000                                     ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                     ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                     ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames
            .dw #sys_render_firstTime                       ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #animation_negra_leftrun                    ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                       ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #sys_ia_negra_move                          ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)
            .db #0x00                                       ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #0x00                                       ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #ENT_NEGRA_SCORE                            ;; IA SCORE         --> score para las IAs
    ;/////////////////

     ;ENTITY_REDONDA
        ;Plantilla para entidad: enemigo > redonda
        man_entity_redonda::
            .db #(ENT_TYPE_RENDER | ENT_TYPE_PHYSICS | ENT_TYPE_ANIMATION | ENT_TYPE_AI | ENT_TYPE_COLISION | ENT_TYPE_ORIENTATION)    ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #ENT_REDONDA_X                                  ;; POSITION_X
            .db #(ENT_REDONDA_Y - SP_REDONDA_H)                ;; POSITION_Y
            .db #ENT_ENEMY_DEFAULT_SPEED                                              ;; SPEED_X
            .db #SP_REDONDA_H                                 ;; HEIGHT      --> alto de la entidad
            .db #SP_REDONDA_W                                 ;; WIDTH       --> ancho de la entidad
            .dw #_sp_redonda_left                             ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                     ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado
            .dw #0x0000                                     ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                     ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                     ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames
            .dw #sys_render_firstTime                       ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #animation_redonda_left                     ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                       ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #sys_ia_redonda_move                        ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)
            .db #0x01                                       ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #0x05                                       ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #ENT_REDONDA_SCORE                          ;; IA SCORE         --> score para las IAs
    ;/////////////////

    ;ENTITY_SEMIFUSA
        ;Plantilla para entidad: enemigo > semifusa
        man_entity_semifusa::
            .db (#ENT_TYPE_RENDER | #ENT_TYPE_PHYSICS | #ENT_TYPE_ANIMATION | #ENT_TYPE_AI | #ENT_TYPE_COLISION | #ENT_TYPE_ORIENTATION)    ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #ENT_SEMIFUSA_X                           ;; POSITION_X
            .db #ENT_SEMIFUSA_Y                           ;; POSITION_Y
            .db #ENT_ENEMY_DEFAULT_SPEED                                        ;; SPEED_X
            .db #SP_SEMIFUSA_H                            ;; HEIGHT      --> alto de la entidad
            .db #SP_SEMIFUSA_W                            ;; WIDTH       --> ancho de la entidad
            .dw #_sp_semifusa_left                        ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                   ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado
            .dw #0x0000                                   ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                   ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                   ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames
            .dw #sys_render_firstTime                     ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #animation_semifusa_leftrun               ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                     ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #sys_ia_semifusa_move                     ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)
            .db #0x00                                     ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #0x00                                     ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #ENT_SEMIFUSA_SCORE                       ;; IA SCORE         --> score para las IAs
    ;/////////////////

    ;ENTITY_BLANCA
        ;Plantilla para entidad: enemigo > blanca
        man_entity_blanca::
            .db (#ENT_TYPE_RENDER | #ENT_TYPE_PHYSICS | #ENT_TYPE_ANIMATION | #ENT_TYPE_AI | #ENT_TYPE_COLISION | #ENT_TYPE_ORIENTATION)    ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #ENT_BLANCA_X                             ;; POSITION_X
            .db #ENT_BLANCA_Y                             ;; POSITION_Y
            .db #ENT_ENEMY_DEFAULT_SPEED                                        ;; SPEED_X
            .db #SP_BLANCA_H                              ;; HEIGHT      --> alto de la entidad
            .db #SP_BLANCA_W                              ;; WIDTH       --> ancho de la entidad
            .dw #_sp_blanca_left                          ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                   ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado
            .dw #0x0000                                   ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                   ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                   ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames
            .dw #sys_render_firstTime                     ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #animation_blanca_leftrun                 ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                     ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #sys_ia_blanca_init                       ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)
            .db #0x00                                     ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #0x00                                     ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #ENT_BLANCA_SCORE                         ;; IA SCORE         --> score para las IAs
    ;/////////////////

    ;ENTITY_PLAYER
        ;Plantilla para entidad: jugador > cuerpo
        man_entity_player::
            .db (#ENT_TYPE_RENDER | #ENT_TYPE_ANIMATION | #ENT_TYPE_AI)  ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #ENT_PLAYER_X                             ;; POSITION_X
            .db #ENT_PLAYER_Y                             ;; POSITION_Y
            .db #00                                       ;; SPEED_X
            .db #SP_PLAYER_H                              ;; HEIGHT      --> alto de la entidad
            .db #SP_PLAYER_W                              ;; WIDTH       --> ancho de la entidad
            .dw #_sp_player_right                         ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                   ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado
            .dw #0x0000                                   ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                   ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                   ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames 
            .dw #sys_render_firstTime                     ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #animation_player_rightidle               ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                     ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #sys_ia_playerDoNothing                   ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)
            .db #0x00                                     ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #0x00                                     ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #0x00                                     ;; IA SCORE         --> score para las IAs
    ;/////////////////

    ;ENTITY_ATACK_RIGHT
        ;Plantilla para los ataques: jugador > ataque derecha
        man_entity_atack_right::
            .db #ENT_TYPE_PHYSICS                         ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #ENT_ATACK_X_RIGHT                        ;; POSITION_X
            .db #ENT_ATACK_Y                              ;; POSITION_Y
            .db #00                                       ;; SPEED_X
            .db #ENT_ATACK_HEIGHT                         ;; HEIGHT      --> alto de la entidad
            .db #ENT_ATACK_WIDTH                          ;; WIDTH       --> ancho de la entidad
            .dw #_sp_sword_attack_vacuum                  ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                   ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado
            .dw #0x0000                                   ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                   ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                   ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames 
            .dw #sys_render_firstTime                     ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #animation_sword_rightattack              ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                     ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #0x0000                                   ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)
            .db #0x00                                     ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #0x00                                     ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #0x00                                     ;; IA SCORE         --> score para las IAs
    ;/////////////////

    ;ENTITY_ATACK_LEFT
        ;Plantilla para los ataques: jugador > ataque izquierda
        man_entity_atack_left::
            .db #ENT_TYPE_PHYSICS                         ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #ENT_ATACK_X_LEFT                         ;; POSITION_X
            .db #ENT_ATACK_Y                              ;; POSITION_Y
            .db #00                                       ;; SPEED_X
            .db #ENT_ATACK_HEIGHT                         ;; HEIGHT      --> alto de la entidad
            .db #ENT_ATACK_WIDTH                          ;; WIDTH       --> ancho de la entidad
            .dw #_sp_sword_attack_vacuum                  ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                   ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado            
            .dw #0x0000                                   ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                   ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                   ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames 
            .dw #sys_render_firstTime                     ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #animation_sword_leftattack               ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                     ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #0x0000                                   ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)
            .db #0x00                                     ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #0x00                                     ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #0x00                                     ;; IA SCORE         --> score para las IAs
    ;/////////////////

    ;ENTITY_SPIRIT
        ;Plantilla para la entidad del fantasma de la animacion de muerte
        man_entity_spirit::
            .db #(ENT_TYPE_RENDER | ENT_TYPE_AI | ENT_TYPE_ANIMATION)                         ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #0                                        ;; POSITION_X
            .db #0                                        ;; POSITION_Y
            .db #00                                       ;; SPEED_X
            .db #ENT_SPIRIT_HEIGHT                        ;; HEIGHT      --> alto de la entidad
            .db #ENT_SPIRIT_WIDTH                         ;; WIDTH       --> ancho de la entidad
            .dw #_sp_spirit_1                             ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                   ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado            
            .dw #0x0000                                   ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                   ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                   ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames 
            .dw #sys_render_firstTime                     ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #animation_spirit                         ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                     ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #sys_ia_die                               ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)    
            .db #ent_ai_st_condemn                        ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #ENT_SPIRIT_ANIMATION_DURATION            ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #0x00                                     ;; IA SCORE         --> score para las IAs
    ;/////////////////

    ;ENTITY_THRESHOLD
        ;Plantilla para la entidad del fantasma de la animacion de muerte
        man_entity_threshold::
            .db #(ENT_TYPE_ORIENTATION)                   ;; TYPE        -->  mascara con el esta (renderizable, deleteable, ...)
            .db #ENT_THRESHOLD_X                          ;; POSITION_X
            .db #ENT_THRESHOLD_Y                          ;; POSITION_Y
            .db #00                                       ;; SPEED_X
            .db #ENT_THRESHOLD_HEIGHT                     ;; HEIGHT      --> alto de la entidad
            .db #ENT_THRESHOLD_WIDTH                      ;; WIDTH       --> ancho de la entidad
            .dw #0x0000                                   ;; SPRITE      --> posicion de memoria donde empieza el sprite almacenado
            .dw #0x0000                                   ;; LAST_SPRITE      --> posicion de memoria donde empieza el ultimo sprite renderizado            
            .dw #0x0000                                   ;; ULTIMA POSICION  --> posicion de la memoria de video en la que estaba el frame anterior 
            .dw #0x0000                                   ;; LAST_SPRITE_2      --> posicion de memoria donde empieza el sprite renderizado hace 2 frames
            .dw #0x0000                                   ;; PENULTIMA POSICION  --> posicion de la memoria de video en la que estaba hace dos frames 
            .dw #sys_render_firstTime                     ;; RENDER_FUNCTION --> posicion de memoria de la funcion que gestiona el render
            .dw #0x0000                                   ;; ANIMACION   --> puntero a la posicion de memoria en la que empieza la animacion
            .db #0x00                                     ;; FRAME       --> el frame actual por el que vas de la animacion
            .dw #sys_ia_threshold_count                   ;; BEHAVIOR    --> puntero a la funcion que gestiona el comportamiento de la entidad (IA o input manager)
            .db #0x00                                     ;; IA STATUS        --> estado en el que se encuentra la ia para la toma de decisiones
            .db #0x00                                     ;; IA CONTADOR      --> contador para las IAs, principalmente para hacer pausas
            .db #0x00                                     ;; IA SCORE         --> score para las IAs
    ;/////////////////

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; RESERVA DE MEMORIA
        next_entity::
            .dw entities

        entities::
            .ds ENTITY_SIZE*NUM_ENTITIES


        threshold_sprites:
            .dw #0x0000
            .dw #_sp_good
            .dw #_sp_great
            .dw #_sp_perfect
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FUNIONALIDADES

    ;MAN_ENTITY_INIT
        ;Inicializa el manager de entity
        ;Inputs:   N/A
        ;Destrois: N/A
        man_entity_init::
            ld de, #entities
            ld a, #0x00
            ld bc, #(ENTITY_SIZE*NUM_ENTITIES)
            call cpct_memset_asm
            ld hl, #entities
            ld (next_entity), hl
        ret
    ;/////////////////

    ;MAN_ENTITY_CREATE_WITH_TEMPLATE
        ;Creas una entidad usando una plantilla y la metes en el array de entidades
        ;Inputs:        HL <- plantilla a usar
        ;Outputs:       IY <- posicion de memoria de la entidad creada
        ;Destrois:      HL
        man_entity_create_with_template::
            ;Guardo en DE la posicion de memoria de la futura entidad para devolverla
            ;Meto DE en la pila porque lo voy a modificar
            ld de, (next_entity)
            push de

            ld bc, #ENTITY_SIZE

            ldir

            ld (next_entity), de
            pop iy

            ret
    ;/////////////////

    ;MAN_ENTITY_PREPARE_TO_CONDEMN
        ;Marca una entidad para borrarla
        ;Inputs:      IY <- Entidad a marcar
        ;Destrois:    A
        man_entity_prepare_to_condemn::
            ;;Empieza el seteo demuerte         

            ld a, ent_x(iy)             ;; / Actualizamos la posicion en X de la entidad
            ld b, ent_width(iy)         ;; | spirit_x = enemy_x + (enemy_widht/2) - (spirit_width/2)
            sra b                       ;; | sra b = (int)B/2
            add b                       ;; |
            add #(-ENT_SPIRIT_WIDTH/2)  ;; |
            ld b, a                     ;; \

            ld a, ent_y(iy)             ;; / Actualizamos la posicion en Y de la entidad
            add #(-ENT_SPIRIT_HEIGHT)   ;; | spirit_y = enemy_y - spirit_height
            ld c, a                     ;; \

            call man_entity_condemn

            call sys_generator_spirit

            ret
    ;/////////////////

    ;MAN_ENTITY_CONDEMN
        ;Marca un fantasma para borrarlo
        ;Inputs:      IY <- Entidad a marcar
        ;Destrois:    A
        man_entity_condemn::
            ;Seteamos el valor de la entidad como "Sentenciada" (1er bit a 1)
            ld a, ent_type(iy)
            or #ENT_TYPE_CONDEMNED ; OR 1000 0000 -> settear el 7º bit a 1 (condenado)
            ld ent_type(iy), a

            ret
    ;/////////////////

    ;MAN_ENTITY_DELETE
        ;Borra una entidad y reajusta el array de entidades
        ;Inputs:      IY <- Entidad para borrar
        ;Destrois: 
        man_entity_delete::
            ;Logica: marca como muerta 1er bit de la mascara de estado
            ;comprobar si es la ultima entidad del array de entidades
            ;si no es la ultima entidad cambiamos de sitio la ultima entidad con la entidad que ha sido borrada
            ;en ambos casos finalmente decrementamos en los bytes que ocupa una entidad el valor de "next_entity"
            ;como se si es la ultima entidad? puedo comprobarlo usando next_entity? puedo comprobarlo de alguna otra forma?
            ;Si tenemos en IY la posicion de memoria a la entidad y tenemos que ent_type(iy) es la mascara de tipo, 
            ;tenemos que ent_type+ENTITY_SIZE(iy) es la mascara tipo de la siguiente entidad. Si es 0x00 quiere decir que en efecto era la ultima entidad

            ;Guardamos IY en la pila porque vamos a modificarlo y no queremos destruir el registro
            push iy
            
            ;;El render borra la entidad
            call sys_render_delete

            ;Actualizamos el valor de next_entity (hacerlo ahora nos facilita las cosas)
            ld hl, (next_entity)
            ld d, #0xFF           ;; Cargamos en D el numero #FF porque queremos cargar un numero negativo en DE
            ld e, #-ENTITY_SIZE
            add hl, de

            ld (next_entity), hl

            ld a, next_ent_type(iy)      ;; Calculamos la posicion del valor type de la siguiente entidad y lo volcamos en A

            or a             ;; if(A==0)  => es la ultima entidad
            jr z, delete_last_entity ;; Saltamos a borrar la ultima entidad directamente

            ;; else => no es la ultima entidad

            ;;Preparamos un ldir
            ld b, #0x00             ;;  /
            ld c, #ENTITY_SIZE      ;; | BC <- Entity size
            pop  de                 ;; | DE <- Entidad sobre la que se copia (IY)
            push iy                 ;; | HL <- Entidad para copiar  new(next_entity)
            ldir                    ;;  \


            ;;Cargamos en IY el valor de la ultima entidad
            ;;Tener en cuenta que como hemos actualizado el valor de (next_entity) ahora apunta
            ;;a la ultima entidad del array, no a la siguiente posicion (libre)
            ld iy, (next_entity)

            delete_last_entity:
                ld ent_type(iy), #0x00

            ;Dejamos IY como estaba
            pop iy

            ret
    ;/////////////////

    ;MAN_ENTITY_UPDATE
        ;Actualiza las entidades
        ;Manda a destruir a todas las entidades que esten condenadas
        ;Destrois:  A, HL  
        man_entity_update::
            ld a, #ENT_TYPE_CONDEMNED
            ld hl, #man_entity_delete
            call man_entity_forall_mask
            ret
    ;/////////////////

    ;MAN_ENTITY_FORALL
        ;Recorre el array de entidades y llama a la funcion que se pasa por cada una de ellas
        ;Inputs:         HL -> Posicion de memoria de la funcion
        ;Destrois:     AF, IY, BC
        ;Midcalls:     IY <- Puntero a entidad por iteracion
        man_entity_forall::
            ;Cargamos la direccion de memoria del array de entidades en IY
            ld iy, #entities
            forall:
                ;Guardamos en la pila HL por si se destruye fuera de la funcion
                push hl   
                ;Guardamos en la pila el punto de retorno para usarlo con ret
                ld bc, #forall_ret_point
                push bc

                ;Cargas el byte estado en A (es una mascara)
                ld a, ent_type(iy)
                ;Compruebas si es 0
                or a

                jr z, end_forall

                ;En IY esta el puntero a entidad
                ;Llamamos a la funcion que se ha pasado por parametro
                jp (hl)

                forall_ret_point:
                    ;Preparamos la siguiente iteracion
                    ld b, #0x00
                    ld c, #ENTITY_SIZE
                    add iy, bc
                    pop hl
                    jr forall

                end_forall:
                    ;Sacamos de la pila IY para que el ret de esta funcion no se ralle
                    pop bc
            ret
    ;/////////////////  

    ;MAN_ENTITY_FORALL_MASK
        ;Recorre el array de entidades y llama a la funcion que se pasa por cada una de ellas que cumplan la mascara que se pasa
        ;Inputs:       HL -> Posicion de memoria de la funcion, A -> Mascara para filtro
        ;Destrois:     AF, IY, BC
        ;Midcalls:     IY <- Puntero a entidad por iteracion
        man_entity_forall_mask::
            ;Cargamos la direccion de memoria del array de entidades en IY
            ld iy, #entities
            forall_mask:
                ;Guardamos la mascara en la pila por si la funcion a la que llamamos va a usar A y HL
                push af 
                push hl

                ;Guardamos el valor de la mascara en B
                ld b, a

                ;Comprobamos si la entidad esta viva (si esta muerta es que no hay mas array)
                ld a, ent_type(iy)
                or a

                ; if(A == 0) --> es la ultima entidad, acabamos el bucle
                jr z, end_forall_mask

                ;ELSE

                ;AND entre la mascara pasada en B y el type de la entidad
                and b
                ;Si los bits de la mascara estaban marcados en type, ahora A y B deberían de ser iguales
                cp b ;Si son iguales, significa que el type de la entidad tenia como minimo los bits en 1 de la mascara tambien a 1

                ;; if (mask.in(entidad[type])) --> si la entidad cumple las condiciones de la mascara
                jr nz, forall_mask_ret_point  ;saltamos al punto en el que nos preparamos para la siguiente iteracion sin llamar a la funcion


                ;Guardamos en la pila el punto de retorno para que el ret de la funcion funcione
                ld bc, #forall_mask_ret_point
                push bc

                ;Llamamos a la funcion que se ha pasado por parametro
                jp (hl)

                forall_mask_ret_point:
                    ;Preparamos la siguiente iteracion
                    ld b, #0x00
                    ld c, #ENTITY_SIZE
                    add iy, bc
                    pop hl
                    pop af
                    jr forall_mask

                end_forall_mask:
                    ;Vaciamos la pila para que no se ralle el ret de esta funcion
                    pop hl
                    pop af


            ret
    ;/////////////////  

    ;MAN_ENTITY_FORALL_PRECISE
        ;Recorre el array de entidades y llama a la funcion que se pasa por cada una de ellas que cumplan la priemra mascara que se pasa y la negacion de la segunda
        ;Inputs:       HL -> Posicion de memoria de la funcion, A -> Mascara para filtro a 1, D -> Mascara de filtro a 0
        ;Destrois:     AF, IY, BC
        ;Midcalls:     IY <- Puntero a entidad por iteracion
        man_entity_forall_precise::
            ;Cargamos la direccion de memoria del array de entidades en IY
            ld iy, #entities
            forall_precise:
                ;Guardamos la mascara en la pila por si la funcion a la que llamamos va a usar A, B y HL
                push af 
                push de
                push hl

                ;Guardamos el valor de la mascara en B
                ld b, a

                ;Comprobamos si la entidad esta viva (si esta muerta es que no hay mas array)
                ld a, ent_type(iy)
                or a

                ; if(A == 0) --> es la ultima entidad, acabamos el bucle
                jr z, end_forall_precise

                ;ELSE

                ;AND entre la mascara pasada en B y el type de la entidad
                and b
                ;Si los bits de la mascara estaban marcados en type, ahora A y B deberían de ser iguales
                cp b ;Si son iguales, significa que el type de la entidad tenia como minimo los bits en 1 de la mascara tambien a 1

                ;; if (mask.in(entidad[type])) --> si la entidad cumple las condiciones de la mascara
                jr nz, forall_precise_ret_point ;saltamos al punto en el que nos preparamos para la siguiente iteracion sin 

                ;; Volvemos a cargar el tipo de la entidad en A
                ld a, ent_type(iy)

                xor #0xFF ;; A = -A


                ;AND entre la mascara pasada en B el type de la entidad invertido
                and d

                cp d

                ;; if (mask.in(!entidad[type])) --> si la entidad cumple las condiciones de la mascara
                jr nz, forall_precise_ret_point  ;saltamos al punto en el que nos preparamos para la siguiente iteracion sin llamar a la funcion


                ;Guardamos en la pila el punto de retorno para que el ret de la funcion funcione
                ld bc, #forall_precise_ret_point
                push bc

                ;Llamamos a la funcion que se ha pasado por parametro
                jp (hl)

                forall_precise_ret_point:
                    ;Preparamos la siguiente iteracion
                    ld b, #0x00
                    ld c, #ENTITY_SIZE
                    add iy, bc
                    pop hl
                    pop de
                    pop af
                    jr forall_precise

                end_forall_precise:
                    ;Vaciamos la pila para que no se ralle el ret de esta funcion
                    pop hl
                    pop de
                    pop af


            ret
    ;/////////////////  
    
    ;MAN_ENTITY_GET_PLAYER
        ;Devuelve la posicion en memoria del jugador (asumimos que siempre es la primera posicion del array de entidades)
        ;Outputs:  IY <- Posicion en memoria del jugador
        ;Destrois: IY
        man_entity_get_player::
            ld iy, #entities
            ret
    ;/////////////////

    ;;MAN_ENTITY_ADD_TYPE
        ; Pone un bit especifico de tipo de una entidad a 1
        ; Inputs:   B <- mascara con el bit que activar, IY <- puntero a entidad
        ; Destrois: A
        man_entity_add_type::
            ld a, (iy)              ;; A = entity['type']
            or b                    ;; A += (CUSTOM_TYPE)
            ld (iy), a              ;; entity['type'] = A
            ret
    ;/////////////////


    ;MAN_ENTITY_REMOVE_TYPE
        ; Pone un bit especifico de tipo de una entidad a 0
        ; Inputs:   B <- mascara con el bit que desactivar, IY <- puntero a entidad
        ; Destrois: A 
        man_entity_remove_type::
            ld a, b                     ;; / Ej: A = 0000 1000 (0x40)
            xor #0xFF                   ;; | Ej: A = -A (1111 0111 [0xF7])
            ld b, a                     ;; | B = A
            ld a, (iy)                  ;; | A = entity['type']
            and b                       ;; | A -= (CUSTOM_TYPE)
            ld (iy), a                  ;; \ entity['type'] = A
            ret
    ;/////////////////


    ;;MAN_ENTITY_THRESHOLD_UPDATE
        ;Actualiza el estado y la IA del umbral 
        ;Inputs:      B <- type of hit
        ;Destrois:      
        man_entity_threshold_update::
            push iy
            push af
            

            ld a, b     ; Cargamos el valor del sprite pasado por el registro B
            
            ld iy, #entities        ;; /
            ld bc, #ENT_THRESHOLD   ;; | Metemos la direccion de memoria de la entidad umbral en IY
            add iy, bc              ;; \




            ld hl, #threshold_sprites   ;; Metemos la direccion de memoria de los sprites en IX 

            add a       ;; A = A*2
            ld c, a     ;; Metemos en C el valor de A para que el registro BC = A*2
            add hl, bc  ;; Ajustamos la direccion de memoria para el sprite que queremos

            ;;IMPORTANTE BORRAR EL SPRITE ANTERIOR SI ES NECESARIO ANTES DE CAMBIAR AL NUEVO SPRTITE
                ;; Borramos el dibujo de la posible entidad anterior
                ld a, ent_contador(iy)          ;; /
                cp #ENT_THRESHOLD_DURATION      ;; | contador == ent_threshold_duration
                jr z, reset_threshold_sprite     ;; \
                

                or a                           ;; / contador == 0
                jr z, reset_threshold_sprite    ;; \
                ;; if(contador == 0 || contador == ent_threshold_duration) reset_threshold_sprite
                ;; else
                 jr reset_threshold_timer
            ;;/////

            reset_threshold_sprite:
                ld ent_render_function_mayor(iy), #<sys_render_firstTime  ;; /
                ld ent_render_function_menor(iy), #>sys_render_firstTime  ;; \ Actualizamos el function para que se renderice como si fuese la primera vez
                ld ent_last_sprite_mayor(iy), #0x00
                ld ent_last_sprite_menor(iy), #0x00
                ld ent_last_sprite_mayor_2(iy), #0x00
                ld ent_last_sprite_menor_2(iy), #0x00

            
            reset_threshold_timer:                          ;; 
            ld ent_contador(iy), #ENT_THRESHOLD_DURATION    ;; Reseteamos el timer

            ld a, (hl)                  ;; /
            ld ent_sprite_mayor(iy), a  ;; | Metemos en el sprite de la entidad threshold
            inc hl                      ;; | el valor del sprite correspondiente al indice
            ld a, (hl)                  ;; | que se ha pasado en el registro A
            ld ent_sprite_menor(iy), a  ;; \


            ld ent_y(iy), #ENT_THRESHOLD_Y      ;; Lo recolocamos en el eje Y


            ld b, #(ENT_TYPE_RENDER | ENT_TYPE_AI)      ;; / Actualizo el tipo de la etiqueta de umbral para que sea renderizable y tenga comportamiento
            call man_entity_add_type                    ;; \
            

            pop af
            pop iy
            ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;MAN_ENTITY_ENEMIES_LEFT
    ;Devuelve los enemigos restantes
    ;Outputs: Flag Z -> 1 o 0 (No quedan enemigos o si, respectivamente)
    man_entity_enemies_left:
        ld hl, #entities            ;/
        ld bc, #(ENTITY_SIZE * 4)   ;|
        add hl, bc                  ;\ Accedemos a la 5nta entidad (Debe ser el primer enemigo)

        push hl
        pop ix

        ld a, ent_type(ix)
        or a
    ret

;////////////////////////
