;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "cpctelera.h.s"
.include "input.h.s"
.include "entity.h.s"
.include "animations.h.s"

;; //////////////////////////////////
;; Memoria
    atack_counter:
        .db #00 

    atack_wait:
        .db #00

    atack_token:
        .db #00

;; //////////////////////////////////

;MAN_INPUT_INIT
    ;Reserva memoria para guardar los datos necesarios para la gestion de inputs del jugador
    ;Inputs:
    ;Outputs:
    man_input_init::
        ld a, #0
        ld (atack_counter), a
        ld (atack_wait), a
        ld (atack_token), a
        ret
;/////////////////

;MAN_INPUT_UPDATE
    ;Lee el teclado y gestiona la logica en funcion de ello
    ;Inputs:
    ;Outputs:
    man_input_update::
        ; call man_entity_get_player  ;; Obtenemos la direccion de memoria del jugador en IY
        ; ld a, #ENT_TYPE_ATACKING    ;; Cargamos el estado atacando
        ; and (iy)                    ;; Comprobamos si esta atacando
        ; or a
        call man_entity_get_player  ;; Obtenemos la direccion de memoria del jugador en IY

        ld a, (atack_wait)          ;; Cargamos el contador de espera de ataque
        or a
        
        ;; if(input.Waiting() == TRUE ) { 
         jr nz, wait_for_atack ;; Logica de espera de ataque
        ;; }
        ;; else if(player.isAtacking() == TRUE ) { 
         ld a, #ENT_TYPE_ATACKING    ;; Cargamos el estado atacando
         and (iy)                    ;; Comprobamos si esta atacando
         or a
         jr z, input_scan   ;; Saltamos al scan
         ;; Comprobamos si el contador de ataque es 0
         ld a, (atack_counter)
         or a
         ;; if(ataqCounter != 0) {
             jr nz, dec_counter
         ;; }
         ;; else {
             call man_input_stop_atacks
             jr end_input_reader 
         ;; }
 
         dec_counter:
             dec a
             ld (atack_counter), a
         ;; }
        ;; else {
         input_scan:
         call cpct_scanKeyboard_asm
         call cpct_isAnyKeyPressed_asm
 
         ;; if (isAnyKeyPressed == FALSE) {
          jr z, free_atack_token ;; break;
         ;; }
         ;; else {
          ld hl, #Key_P
          ;; if (isKeyPressed(Key_Right)) {
           call cpct_isKeyPressed_asm
           jr z, set_off_right_token
           ;; if (token == 1) {
            ld a, (atack_token)
            and #0x01
            or a
            jr nz, key_not_right ;; Si el token esta activo es que sigue pulsando la tecla asi que no ejecutamos la logica
           ;; }
           ;; else {
            ;; TODO: RIGHT IS PRESSED
            ;;ld de, #ENT_PLAYER_RIGHT_ATACK
            call man_input_atack_right           ;; |
            ld a, #INPUT_ATACK_WAIT              ;; |
            ld (atack_wait), a                   ;; \

            ld a, (atack_token)
            or #0x01
            ld (atack_token), a

            jr end_input_reader
           ;; }
           set_off_right_token:
            ld a, (atack_token)
            and #0xFE
            ld (atack_token), a
           ;; }
          ;; }
          ;; else {
           key_not_right:
            ld hl, #Key_O
            ;; if (isKeyPressed(Key_Left)) {
             call cpct_isKeyPressed_asm
             jr z, set_off_left_token
             ;; if (token == 2) {
              ld a, (atack_token)
              and #0x02
              or a
              jr nz, end_input_reader ;; Si el token esta activo es que sigue pulsando la tecla asi que no ejecutamos la logica
             ;; }
             ;;TODO: LEFT IS PRESSED
             ;;ld de, #ENT_PLAYER_LEFT_ATACK
             call man_input_atack_left
             ld a, #INPUT_ATACK_WAIT            ;; | 
             ld (atack_wait), a                 ;; \

             ld a, (atack_token)
             or #0x02
             ld (atack_token), a
             
             jr end_input_reader                
            ;; }
            set_off_left_token:
             ld a, (atack_token)
             and #0xFD
             ld (atack_token), a
             jr end_input_reader

            ;; }
          ;; }
         ;; }
        ;; }
        wait_for_atack:
            ld a, (atack_wait)
            dec a
            ld (atack_wait), a

            or a
            ; if(atack_wait['counter'] != 0){
             jr nz, end_input_reader
            ; }
            ; else {
                ;; Ponemos el bit del type de la entidad player "atacando" a 1
                ld b, #ENT_TYPE_ATACKING
                call man_entity_add_type
                jr end_input_reader
            ; }

        free_atack_token:
            ld a, #0x00
            ld (atack_token), a
        end_input_reader:
        ret
;/////////////////

;MAN_INPUT_ATACK
    ;Activa una de las entidades de ataque
    ;Inputs:  DE <- Orientacion del ataque, IY <- Posicion de memoria del jugador/array de entidades
    ;Outputs:
    ;Destrois: A
    man_input_atack:
        ;; Quitamos el bit del type de la entidad player "atacking" a 0
        ld b, #ENT_TYPE_ATACKING
        call man_entity_remove_type

        
        ;; Puntero a ataque
        add iy, de

        ;; Ponemos el bit del type de la entidad ataque "renderizable" a 1
        ld b, #(ENT_TYPE_RENDER | ENT_TYPE_ANIMATION)
        call man_entity_add_type

        ;; Quitamos el bit del type de la entidad player "atacking" a 0
        ld b, #ENT_TYPE_ATACKING
        call man_entity_remove_type

        ;; Activamos el contador para la duracion del ataque
        ld a, #INPUT_ATACK_COUNTER
        ld (atack_counter), a


        ret
;/////////////////

;MAN_INPUT_ATACK_RIGHT
    ; Actualiza al player para que ataque y cambia su animacion
    ;Inputs:  IY <- Posicion de memoria del jugador/array de entidades
    ;Outputs:
    ;Destrois: A, DE
    man_input_atack_right:
        ;; Por conveniencia asumimos que *(player) == *(entityArray)
        push iy
        
        ;; Ponemos el bit del type de la entidad player "orientacion" a 0
        ld b, #ENT_TYPE_ORIENTATION
        call man_entity_remove_type

        ;; Cambiamos a la animacion de atacar para el player
        ld ent_frame(iy), #0 
        ld ent_animation_mayor(iy), #<animation_player_rightattack
        ld ent_animation_menor(iy), #>animation_player_rightattack


        ;; Puntero a ataque
        ld de, #ENT_PLAYER_RIGHT_ATACK
        call man_input_atack

        ;; Cambiamos a la animacion de atacar para el ataque
        ld ent_frame(iy), #0 
        ld ent_animation_mayor(iy), #<animation_sword_rightattack
        ld ent_animation_menor(iy), #>animation_sword_rightattack

        pop iy ; Recuperamos el valor de IY        
        ret
;////////////////

;MAN_INPUT_ATACK_LEFT
    ; Actualiza al player para que ataque y cambia su animacion
    ;Inputs:  IY <- Posicion de memoria del jugador/array de entidades
    ;Outputs:
    ;Destrois: A, DE
    man_input_atack_left:
        ;; Por conveniencia asumimos que *(player) == *(entityArray)
        push iy


        ;; Ponemos el bit del type de la entidad player "orientacion" a 0
        ld b, #ENT_TYPE_ORIENTATION
        call man_entity_add_type

        ;; Cambiamos a la animacion de atacar para el player
        ld ent_frame(iy), #0 
        ld ent_animation_mayor(iy), #<animation_player_leftattack
        ld ent_animation_menor(iy), #>animation_player_leftattack


        ;; Puntero a ataque
        ld de, #ENT_PLAYER_LEFT_ATACK
        call man_input_atack

        ;; Cambiamos a la animacion de atacar para el ataque
        ld ent_frame(iy), #0 
        ld ent_animation_mayor(iy), #<animation_sword_leftattack
        ld ent_animation_menor(iy), #>animation_sword_leftattack

        pop iy ; Recuperamos el valor de IY

        ret
;////////////////

;MAN_INPUT_STOP_ONE_ATACK
    ;Desactiva la entidad de ataque indicada por parametro
    ;Inputs:  DE <- Orientacion del ataque, IY <- Posicion de memoria del jugador/array de entidades
    ;Outputs:
    man_input_stop_one_atack:
        ;; Por conveniencia asumimos que *(player) == *(entityArray)
        
        ;; Puntero a ataque
        add iy, de
        
        ;; Ponemos el bit del type de la entidad de ataque "renderizable" a 0 
        ld b, #(ENT_TYPE_RENDER | ENT_TYPE_ANIMATION)
        call man_entity_remove_type

        ret
;/////////////////

;MAN_INPUT_STOP_ATACKS
    ;Llama a man_input_stop_one_atack por cada ataque y luego setea el jugador a "no atacando"
    man_input_stop_atacks:
        ;; IMPORTANTE: posible optimizacion guardando que entidad de ataque es la que esta activa

        ;; Guardo la posicion de la entidad jugador/array entidades en la pila
        call man_entity_get_player
        push iy

        ;; Ataque izquierda
        ld de, #ENT_PLAYER_LEFT_ATACK
        call man_input_stop_one_atack ;; Este metodo destruye IY asi que luego tendre que recuperarlo de la pila

        ;; Recuperamos IY de la pila y lo volvemos a meter para repetir el proceso
        pop iy
        push iy

        ;; Ataque derecha
        ld de, #ENT_PLAYER_RIGHT_ATACK
        call man_input_stop_one_atack ;; Este metodo destruye IY asi que luego tendre que recuperarlo de la pila


        ;; Le quitamos al jugador del estado atacar
        pop iy                      ;; | IY = *(PLAYER)
        ld b, #ENT_TYPE_ATACKING    ;; / A = 0100 0000 (0x40)
        call man_entity_remove_type
        
        ret
;/////////////////

