;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "man/int.h.s"
.include "music/music.h.s"

   uncontador: 
      .db 06
   contador_sfx: 
      .db 3
   sfx_type: 
      .db 00
   sfx_status: 
      .db 00
   render_cap:: 
      .db 00

   man_int_handler::

      push af
      push bc
      push de
      push hl

      ;; Contador de capado de bucle
         ld a, (render_cap)
         inc a
         ld (render_cap), a
      ;; ///////


      ld    a, (uncontador)
      dec   a
      jr    nz, _cont
   _zero:
      function_ir_handler = . + 1
      call cpct_akp_musicPlay_asm
      ld    a, #6
   _cont:
      ld    (uncontador), a

      pop hl
      pop de
      pop bc
      pop af
      
      ei
      reti

   man_int_init::
      ld    hl, #0x38
      ld    (hl), #0xC3
      inc   hl
      ld    (hl), #<man_int_handler
      inc   hl
      ld    (hl), #>man_int_handler
      inc   hl
      ld    (hl), #0xC9

      ld a, #0
      ld (render_cap), a
      ret


 ;;;Función para inicializar una canción
  ;;;Se le pasa por DE la canción que se quiera reproducir
   man_music_Init::
      ;ld    de, #_level1_song
      call cpct_akp_musicInit_asm
      ;call man_sfx_init
      ret

   man_music_win::
      ld    de, #_win_song
      call cpct_akp_musicInit_asm
      ;call man_sfx_init
      ret

   man_music_menu::
      ld    de, #_menum_song
      call cpct_akp_musicInit_asm
      ;call man_sfx_init
      ret

   man_music_death::
      ld    de, #_death_song
      call cpct_akp_musicInit_asm
      ;call man_sfx_init
      ret


 ;;;Función para inicializar una efecto de sonido
  ;;;Se le pasa por DE el efecto que se quiera reproducir
   man_sfx_init::
      ld de, #_good_sfx
      call cpct_akp_SFXInit_asm
      ; ld de, #_great_sfx
      ; call cpct_akp_SFXInit_asm
      ; ld de, #_perfect_sfx
      ; call cpct_akp_SFXInit_asm
      ret



   man_sfx_play::
      ld a, (sfx_type)
      cp #0
      ret z
      cp #1
      jr z, man_sfx_good
      cp #2
      jr z, man_sfx_great
      cp #3
      jp z, man_sfx_perfect

   man_sfx_good:
      ld a, (sfx_status)
      cp #1
      jr z, man_sfx_good_1
      cp #2 
      jr z, man_sfx_good_2

      man_sfx_good_1:

         push hl
         push bc
         push de
         push af

         ld    a, (contador_sfx)
         or    a
         jr    z, end_sfx_g1
               
         dec   a
         ld    (contador_sfx), a
         ld    l, #1
         ld    h, #8
         ld    e, #69
         ld    d, #125
         ld    bc, #0
         ld    a, #4


         call cpct_akp_SFXPlay_asm
         jr pop_sfx_g1
               
         end_sfx_g1:
            ld a, #10
            ld (contador_sfx), a
            ld a, #2
            ld (sfx_status), a
            ; ld a, #1
            ; call cpct_akp_SFXStop_asm
         
         pop_sfx_g1:

         pop af
         pop de
         pop bc
         pop hl
         
         ret

      man_sfx_good_2:

         push hl
         push bc
         push de
         push af

         ld    a, (contador_sfx)
         or    a
         jr    z, end_sfx_g2
               
         dec   a
         ld    (contador_sfx), a
         ld    l, #1
         ld    h, #8
         ld    e, #74
         ld    d, #125
         ld    bc, #0
         ld    a, #4


         call cpct_akp_SFXPlay_asm
         jr pop_sfx_g2
               
         end_sfx_g2:
            ld (sfx_type), a
            ld a, #4
            call cpct_akp_SFXStopAll_asm
         
         pop_sfx_g2:

         pop af
         pop de
         pop bc
         pop hl
         
         ret

         ;call cpct_akp_SFXStop_asm


   man_sfx_great:
      ld a, (sfx_status)
      cp #1
      jr z, man_sfx_great_1
      cp #2 
      jr z, man_sfx_great_2
      cp #3
      jr z, man_sfx_great_3
      man_sfx_great_1:

         push hl
         push bc
         push de
         push af

         ld    a, (contador_sfx)
         or    a
         jr    z, end_sfx_gr1
               
         dec   a
         ld    (contador_sfx), a
         ld    l, #1
         ld    h, #8
         ld    e, #69
         ld    d, #125
         ld    bc, #0
         ld    a, #4


         call cpct_akp_SFXPlay_asm
         jr pop_sfx_gr1
               
         end_sfx_gr1:
            ld a, #5
            ld (contador_sfx), a
            ld a, #2
            ld (sfx_status), a
            ; ld a, #1
            ; call cpct_akp_SFXStop_asm
         
         pop_sfx_gr1:

         pop af
         pop de
         pop bc
         pop hl
         
         ret   

      man_sfx_great_2:

         push hl
         push bc
         push de
         push af

         ld    a, (contador_sfx)
         or    a
         jr    z, end_sfx_gr2
               
         dec   a
         ld    (contador_sfx), a
         ld    l, #1
         ld    h, #8
         ld    e, #74
         ld    d, #125
         ld    bc, #0
         ld    a, #4


         call cpct_akp_SFXPlay_asm
         jr pop_sfx_gr2
               
         end_sfx_gr2:
            ld a, #5
            ld (contador_sfx), a
            ld a, #3
            ld (sfx_status), a
         
         pop_sfx_gr2:

         pop af
         pop de
         pop bc
         pop hl
         
         ret   

      man_sfx_great_3:

         push hl
         push bc
         push de
         push af

         ld    a, (contador_sfx)
         or    a
         jr    z, end_sfx_gr3
               
         dec   a
         ld    (contador_sfx), a
         ld    l, #1
         ld    h, #11
         ld    e, #78
         ld    d, #125
         ld    bc, #0
         ld    a, #4


         call cpct_akp_SFXPlay_asm
         jr pop_sfx_gr3
               
         end_sfx_gr3:
            ld (sfx_type), a
            ld a, #4
            call cpct_akp_SFXStopAll_asm
         
         pop_sfx_gr3:

         pop af
         pop de
         pop bc
         pop hl
         
         ret    

   man_sfx_perfect:
      ld a, (sfx_status)
      cp #1
      jr z, man_sfx_perfect_1
      cp #2 
      jr z, man_sfx_perfect_2
      cp #3
      jr z, man_sfx_perfect_3
      man_sfx_perfect_1:

         push hl
         push bc
         push de
         push af

         ld    a, (contador_sfx)
         or    a
         jr    z, end_sfx_p1
               
         dec   a
         ld    (contador_sfx), a
         ld    l, #1
         ld    h, #8
         ld    e, #74
         ld    d, #125
         ld    bc, #0
         ld    a, #4


         call cpct_akp_SFXPlay_asm
         jr pop_sfx_p1
               
         end_sfx_p1:
            ld a, #5
            ld (contador_sfx), a
            ld a, #2
            ld (sfx_status), a
            ; ld a, #1
            ; call cpct_akp_SFXStop_asm
         
         pop_sfx_p1:

         pop af
         pop de
         pop bc
         pop hl
         
         ret   

      man_sfx_perfect_2:

         push hl
         push bc
         push de
         push af

         ld    a, (contador_sfx)
         or    a
         jr    z, end_sfx_p2
               
         dec   a
         ld    (contador_sfx), a
         ld    l, #1
         ld    h, #8
         ld    e, #79
         ld    d, #125
         ld    bc, #0
         ld    a, #4


         call cpct_akp_SFXPlay_asm
         jr pop_sfx_p2
               
         end_sfx_p2:
            ld a, #5
            ld (contador_sfx), a
            ld a, #3
            ld (sfx_status), a
         
         pop_sfx_p2:

         pop af
         pop de
         pop bc
         pop hl
         
         ret   

      man_sfx_perfect_3:

         push hl
         push bc
         push de
         push af

         ld    a, (contador_sfx)
         or    a
         jr    z, end_sfx_p3
               
         dec   a
         ld    (contador_sfx), a
         ld    l, #1
         ld    h, #11
         ld    e, #84
         ld    d, #125
         ld    bc, #0
         ld    a, #4


         call cpct_akp_SFXPlay_asm
         jr pop_sfx_p3
               
         end_sfx_p3:
            ld (sfx_type), a
            ld a, #4
            call cpct_akp_SFXStopAll_asm
         
         pop_sfx_p3:

         pop af
         pop de
         pop bc
         pop hl
         
         ret    
        
      
   man_sfx_trigger::
         ld (sfx_type), a
         ld a, #3
         ld (contador_sfx), a
         ld a, #1
         ld (sfx_status), a
      ret