;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "man/entity.h.s"
.include "levels.h.s"
.include "sys/generator.h.s"
.include "tools/math.h.s"
.include "sys/render.h.s"
.include "main.h.s"
.include "sys/render.h.s"
.include "sys/score.h.s"
.include "man/game.h.s"
.include "man/int.h.s"
.include "music/music.h.s"
.include "man/menu.h.s"
.include "cpctelera.h.s"
;//////////////////////////////////////////////////////
; MEMORIA
    current_level:: 
        .dw level_1 

    current_level_entity:: 
        .dw level_1 

    levels_order::
        .dw level_1
        .dw level_2
        .dw level_3
        .dw level_4
        .dw 0x0000
    
    levels_order_step::
        .dw levels_order

    spawn_timer:
        .db 0

    entities_left_counter:: 
        .dw 0
    
    score_timer:
        .db SCORE_TIME

    level_end_timer:
        .db LEVEL_END_TIME

    score_label:
        .asciz "Score: "

    score_total_label:
        .asciz "Total: "

    level_end_label:
        .asciz "Level Complete"

    text_blink_timer:
        .db TEXT_BLINK_TIME

    level_next_label:
        .asciz "Press [SPACE]"

    ;//////////////////////////////////////////////////
    ; Level Labels
        level_labels:
            .dw level_1_label
            .dw level_2_label
            .dw level_3_label
            .dw level_4_label
        
        level_1_label:
            .asciz "Level 1"
        
        level_2_label:
            .asciz "Level 2"

        level_3_label:
            .asciz "Level 3"

        level_4_label:
            .asciz "Final Level"
        
        level_labels_step:
            .dw level_labels

        level_label_timer:
            .db LEVEL_LABEL_TIME
    ;//////////////////////////////////////////////////

    victory_label:
            .asciz "YOU WON!"
    ;//////////////////////////////////////////////////
    ;Music Labels
        music_labels::
            .dw _level1_song
            .dw _level3_song
            .dw _level2_song
            .dw _level4_song

        music_order:
            .dw music_labels
;//////////////////////////////////////////////////////

;//////////////////////////////////////////////////////
; Levels 
    ;Primer byte: 
        ;bits 1 a 7 -> Tiempo en frames/2 (Si quieres 40 frames pones un 20)
        ;bit 8 -> Dirección (1 => mirar hacia la izquierda, 0 => mirar hacia la derecha) 
    ;Byte 2, Byte 3: Plantilla a usar
    
    level_1:: 
    
        .db (0b00000000 | 6)
        .dw sys_generator_negra

        .db (0b10000000 | 16)
        .dw sys_generator_negra

        .db (0b00000000 | 18)
        .dw sys_generator_negra

        .db (0b10000000 | 3)
        .dw sys_generator_negra

        .db (0b00000000 | 13)
        .dw sys_generator_redonda

        .db (0b10000000 | 18)
        .dw sys_generator_negra

        .db (0b00000000 | 18)
        .dw sys_generator_redonda

        .db (0b10000000 | 15)
        .dw sys_generator_redonda

        .db (0b00000000 | 3)
        .dw sys_generator_negra

        .db (0b10000000 | 3)
        .dw sys_generator_redonda

        .db (0b10000000 | 16)
        .dw sys_generator_negra
        
        .db (0b10000000 | 19)
        .dw sys_generator_negra

        .db (0b10000000 | 16)
        .dw sys_generator_negra

        .db (0b00000000 | 7)
        .dw sys_generator_negra

        .db (0b10000000 | 3)
        .dw sys_generator_redonda

        .db (0b00000000 | 3)
        .dw sys_generator_redonda

        .db 0x00    

    level_2::   
        .db (0b10000000 | 01)
        .dw sys_generator_redonda
        .db (0b10000000 | 15)
        .dw sys_generator_negra
        .db (0b10000000 | 23)


        .dw sys_generator_negra
        .db (0b00000000 | 30)
        .dw sys_generator_redonda
        .db (0b00000000 | 20)
        .dw sys_generator_redonda
        .db (0b10000000 | 22)
        .dw sys_generator_blanca
        .db (0b00000000 | 20)
        .dw sys_generator_redonda


        .db (0b10000000 | 15)
        .dw sys_generator_blanca
        .db (0b00000000 | 05)
        .dw sys_generator_redonda
        .db (0b10000000 | 15)
        .dw sys_generator_negra
        .db (0b00000000 | 10)
        .dw sys_generator_redonda
        .db (0b00000000 | 10)

        .dw sys_generator_blanca
        .db (0b00000000 | 20)
        .dw sys_generator_redonda


        .db (0b10000000 | 05)
        .dw sys_generator_blanca
        .db (0b00000000 | 22)
        .dw sys_generator_blanca
        .db (0b00000000 | 03)
        .dw sys_generator_redonda
        .db (0b10000000 | 20)
        .dw sys_generator_blanca
        .db (0b10000000 | 20)
        .dw sys_generator_negra
        .db (0b00000000 | 10)
        .dw sys_generator_redonda

        .db (0b10000000 | 15)
        .dw sys_generator_redonda
        .db (0b00000000 | 10)
        .dw sys_generator_redonda
        .db (0b10000000 | 10)
        .dw sys_generator_redonda

        .db 0x00
        
    level_3::
        .db (0b00000000 | 1)
        .dw sys_generator_negra
        .db (0b00000000 | 17)
        .dw sys_generator_redonda
        .db (0b10000000 | 2)
        .dw sys_generator_redonda
        .db (0b10000000 | 10)
        .dw sys_generator_negra
        .db (0b10000000 | 13)
        .dw sys_generator_blanca
        .db (0b00000000 | 18)
        .dw sys_generator_blanca
        .db (0b00000000 | 32)
        .dw sys_generator_negra

        .db (0b00000000 | 15)
        .dw sys_generator_negra
        .db (0b10000000 | 5)
        .dw sys_generator_redonda
        .db (0b00000000 | 3)
        .dw sys_generator_redonda


        .db (0b10000000 | 5)
        .dw sys_generator_negra
        .db (0b00000000 | 13)
        .dw sys_generator_negra

        .db (0b00000000 | 17)
        .dw sys_generator_negra
        .db (0b10000000 | 11)
        .dw sys_generator_redonda
        .db (0b00000000 | 2)
        .dw sys_generator_negra
        .db (0b10000000 | 5)
        .dw sys_generator_redonda
        .db (0b00000000 | 1)
        .dw sys_generator_negra
        

        .db (0b10000000 | 14)
        .dw sys_generator_blanca
        .db (0b00000000 | 27)
        .dw sys_generator_negra
        .db (0b10000000 | 19)
        .dw sys_generator_redonda
        .db (0b10000000 | 3)
        .dw sys_generator_semifusa
        
        .db (0b10000000 | 27)
        .dw sys_generator_redonda
        .db (0b00000000 | 4)
        .dw sys_generator_redonda
        .db (0b00000000 | 27)
        .dw sys_generator_blanca
        .db (0b10000000 | 15)
        .dw sys_generator_semifusa

        .db 0x00

    level_4:
        .db (0b10000000 | 2)
        .dw sys_generator_negra
        .db (0b00000000 | 4)
        .dw sys_generator_redonda

        .db (0b10000000 | 9)
        .dw sys_generator_blanca

        .db (0b00000000 | 18)
        .dw sys_generator_semifusa
        .db (0b10000000 | 8)
        .dw sys_generator_negra
        .db (0b00000000 | 4)
        .dw sys_generator_redonda

        .db (0b10000000 | 5)
        .dw sys_generator_semifusa

        .db (0b00000000 | 3)
        .dw sys_generator_redonda

        .db (0b10000000 | 14)
        .dw sys_generator_blanca

        .db (0b00000000 | 18)
        .dw sys_generator_redonda
        .db (0b00000000 | 10)
        .dw sys_generator_semifusa
        .db (0b10000000 | 2)
        .dw sys_generator_negra
        .db (0b00000000 | 1)
        .dw sys_generator_redonda

        ;Descanso en el nivel
        .db (0b00000000 | 78)
        .dw sys_generator_semifusa
        .db (0b10000000 | 2)
        .dw sys_generator_semifusa
        .db (0b00000000 | 10)
        .dw sys_generator_redonda

        .db (0b00000000 | 6)
        .dw sys_generator_blanca
        .db (0b10000000 | 15)
        .dw sys_generator_blanca

        .db (0b00000000 | 36)
        .dw sys_generator_semifusa
        .db (0b10000000 | 5)
        .dw sys_generator_semifusa
        .db (0b10000000 | 2)
        .dw sys_generator_redonda
        
        .db 0x00
;//////////////////////////////////////////////////////

;MAN_LEVEL_INIT
    ;Establece los valores iniciales del sistema de niveles
    man_level_init::
        ;Reseteamos todos los valores
        ld bc, #0x0000
        ld (entities_left_counter), bc
        ld (spawn_timer), bc

        ld bc, #0xFFFF
        ld (last_entities_left_counter), bc
        ld (last_score), bc

        ;Seteamos el resto de valores a lo que corresponda
        ld hl, (levels_order_step)  ;HL = direccion de memoria del paso de levels_order actual
        ld e, (hl)                  ;/
        inc hl                      ;|
        ld d, (hl)                  ;|HL = Direccion de memoria del nivel actual
        ex de, hl                   ;\
        ld (current_level), hl      ;Current_level = Direccion de memoria del nivel actual

        ld hl, (current_level)
        ld (current_level_entity), hl
        ; ld hl, #(music_order)
        ; call man_music_Init
        call man_level_setCounter
        call man_level_setTimer
    ret
;///////////////// 

;MAN_LEVEL_UPDATE
    ;Actualiza el sistema de niveles
    man_level_update::
        f_logic_level = . + 1  
        jp man_level_read       
    ret
;///////////////// 

;MAN_LEVEL_READ
    ;Recorre el nivel llamando al generador de enemigos cuando corresponde
    ;Destrois: A, Hl, BC, DE
    man_level_read::

        ld a, (spawn_timer)     ;/
        dec a                   ;| spawn_timer--
        ld (spawn_timer), a     ;\

        ;;;if(spawn_timer == 0){
                or a
                jr nz, end_if_spawn_timer_is_0
                ;;;@(spawn_timer == 0)
                    ld hl, (current_level_entity)   ;HL = Direccion de memoria del paso actual
                    ld a, (hl)                      ;A = (DIRECTION | (TIME/2))
                    and #0b10000000                 ;A = Direction
                    inc hl                          ;HL = Direccion de de la direccion de memoria de la funcion del generator a saltar
                    ld e, (hl)                      ;D = 1byte direccion de memoria de la funcion del generator a saltar 
                    inc hl
                    ld d, (hl)                      ;E = 2byte direccion de memoria de la funcion del generator a saltar
                    ex de, hl                       ;HL = Direccion de sys_generator_xxx
                    push hl                         ;Guardo el valor de hl 
                    push de                         ;Guardo el valor de de
                    ld bc, #reset_spawn_timer       ;/
                    push bc                         ;|
                    jp (hl)                         ;\call sys_generator_xxx
                    reset_spawn_timer:
                    pop hl                          ;/
                    pop de                          ;\Recupero de y hl en orden inverso para no tener que intercambiarlos
                    inc hl                          ;HL = Direccion de memoria del siguiente paso
                    ld (current_level_entity), hl   
                    call man_level_setTimer

                    ;Reducir el contador de enemigos restantes
                    push af
                    ld hl, (entities_left_counter)
                    ld bc, #0001
                    call tools_math_bcdsub
                    ld (entities_left_counter), hl
                    pop af

                    ;;;if(spawn_timer == 0)         ;Esto va a pasar si se ha acabado el nivel
                        or a
                        jr nz, not_last_entity
                        ;;;@(spawn_timer == 0)
                            ld hl, #man_level_ending    ;/Cambiamos la logica del update con codigo automodificable para
                            ld (f_logic_level), hl      ;\que deje de hacer cosas 
                        ;;;
                    not_last_entity:
                    ;;;
                ;;;
                end_if_spawn_timer_is_0:
            ;;;}
    ret
;///////////////// 

;MAN_LEVEL_END
    ;Gestiona el final del nivel
    man_level_ending::
        ;;;if(enemigos_vivos == 0){
            call man_entity_enemies_left
            ret nz
            ;;;@(enemigos_vivos == 0)
                ;Cambiamos el metodo de levels que se ejecuta por uno que comprueba un timer antes de pasar al resumen del nivel
                ld hl, #man_level_checkEndTimer    
                ld (f_logic_level), hl
                ld hl, #cpct_akp_stop_asm
                ld (function_ir_handler), hl
                call man_music_win   
                ld hl, #cpct_akp_musicPlay_asm
                ld (function_ir_handler), hl
            ;;;
        ;;;}
    ret
;///////////////// 

;MAN_LEVEL_CHECKENDTIMER
    ;Comprueba un timer en los niveles para que pase un tiempo asequible desde que te pasas el nivel hasta que te sale la pantalla resumen
    man_level_checkEndTimer::
        ;;;if(level_end_timer == 0){
            ld a, (level_end_timer)
            or a
            jr nz, level_end_timer_not_0
            ;;;@(level_end_timer == 0)
                ;De momento limpiamos la pantalla
                ld hl, #man_level_sumary_init
                ld (game_state), hl
                jr end_if_level_end_timer
            ;;;
            level_end_timer_not_0:
            ;;;@(level_end_timer != 0)
                dec a
                ld (level_end_timer), a
            ;;;
        end_if_level_end_timer:
        ;;;}
    ret
;///////////////// 

;MAN_LEVEL_SETTIMER
    ;Coloca en spawn_timer el tiempo que va a tardar en spawnear la siguiente entidad 
    ;Output: A -> Tiempo (En frames)
    man_level_setTimer:
        ld hl, (current_level_entity)       ;HL = Direccion de memoria al byte con la informacion del tiempo 
        ld a, (hl)                          ;A = (DIRECTION | (TIME/2))
        and #0b01111111                     ;A = (TIME/2)
        add a, a                            ;A = TIME <=> A = A + A = (TIME/2) + (TIME/2) = TIME 
        ld (spawn_timer), a                 ;SpawnTimer = A = TIME
    ret
;///////////////// 

;MAN_LEVEL_SETCOUNTER
    ;Coloca en el contador de entidades restantes el numero de entidades del nivel 
    man_level_setCounter:
        ld de, (current_level_entity)   ;BC = direccion de memoria en la que empieza el nivel actual
        inc_counter_loop:
        ;;;if((DIRECCION | TIEMPO) == 0){
            ld a, (de)                      ;A = (DIRECCION | TIEMPO) -> Si vale 0 es porque se acaba el nivel
            or a
            jr z, set_back_current_level
            ;;;@((DIRECCION | TIEMPO) != 0)
                ld hl, (entities_left_counter)   ;/
                ld bc, #0001                     ;|Sumamos 1 al contador pero procurando que se quede en decimal
                call tools_math_bcdadd           ;|    
                ld (entities_left_counter), hl   ;\
                
                ld hl,  #ENTITY_LEVEL_BYTES
                add hl, de                      ;Saltamos al proxima entidad
                ex de, hl                       ;Pasamos la informacion de la proxima entidad a DE    
                jr inc_counter_loop             ;Volvemos a comprobar para la siguiente entidad
            ;;;     
        ;;;}
        set_back_current_level:
        ld hl, (current_level)          ;/
        ld (current_level_entity), hl   ;\Volvemos a poner la entidad a generar al principio del nivel      
    ret
;/////////////////

;MAN_LEVEL_SUMARY_INIT
    man_level_sumary_init:
        call change_screen_to_show_C000
        call sys_render_cleanScreenBlack
        ld l, #char_color_white         ;Color de letra
        ld h, #char_color_black         ;Color de fondo
        call cpct_setDrawCharM0_asm


        ld iy, #level_end_label
        ld c, #LEVEL_END_LABEL_X
        ld b, #LEVEL_END_LABEL_Y
        call drawString

        call drawScoreSummary

        ld hl, #man_level_sumary_update
        ld (game_state), hl
    ret
;/////////////////

;MAN_LEVEL_SUMARY_UPDATE
    man_level_sumary_update:
        ;;;if(score_timer == 0){
            ld a, (score_timer)
            or a
            jr nz, score_time_not_0
            ;;;@(score_timer == 0)
                ;Reseteamos el contador y cambiamos los scores
                ld a, #SCORE_TIME
                ld (score_timer), a

                function_to_update_summary = . + 1
                call man_level_sumary_update_unidades

                jr end_if_score_time
            ;;;
            score_time_not_0:
            ;;;@(score_timer != 0)
                ;Decrementamos el contador
                dec a
                ld (score_timer), a
            ;;;
        end_if_score_time:
        ;;;}

        ;Pintamos el score y el total
        call drawScoreSummary
        call cpct_waitVSYNC_asm
    ret
;/////////////////

;MAN_LEVEL_SUMARY_UPDATE_UNIDADES
    man_level_sumary_update_unidades::
        ;;;if(score[unidades] != 0){
                ld hl, (score)
                ld a, l                     ; Si el score es de 9753 nos quedamos con el 53
                and #0b00001111               ; Si en A hay un 53 nos quedamos con el 3
                or a
                jr z, score_unidades_is_0           
                ;;;@(score[unidades] != 0)
                    ;Restamos una unidad al score
                    ld bc, #0x0001
                    call tools_math_bcdsub
                    ld (score), hl
                    ld bc, #0x0001
                    ld hl, (score_total)
                    call tools_math_bcdadd
                    ld (score_total), hl
                    jr end_if_score_unidades
                ;;;
                score_unidades_is_0:
                ;;;@(score[unidades] == 0)
                    ld hl, #man_level_sumary_update_decenas
                    ld (function_to_update_summary), hl
                ;;;
            end_if_score_unidades:
            ;;;}
    ret
;/////////////////

;MAN_LEVEL_SUMARY_UPDATE_DECENAS
    man_level_sumary_update_decenas::
        ;;;if(score[decenas] != 0){
                ld hl, (score)
                ld a, l                     ; Si el score es de 9753 nos quedamos con el 53
                and #0b11110000               ; Si en A hay un 53 nos quedamos con el 5
                or a
                jr z, score_decenas_is_0           
                ;;;@(score[decenas] != 0)
                    ;Restamos una decena al score
                    ld bc, #0x0010
                    call tools_math_bcdsub
                    ld (score), hl
                    ;Sumamos una decena al total
                    ld bc, #0x0010
                    ld hl, (score_total)
                    call tools_math_bcdadd

                    ld (score_total), hl
                    jr end_if_score_decenas
                ;;;
                score_decenas_is_0:
                ;;;@(score[decenas] == 0)
                    ld hl, #man_level_sumary_update_centenas
                    ld (function_to_update_summary), hl
                ;;;
            end_if_score_decenas:
            ;;;}
    ret
;/////////////////

;MAN_LEVEL_SUMARY_UPDATE_CENTENAS
    man_level_sumary_update_centenas:
        ;;;if(score[centenas] != 0){
            ld hl, (score)
            ld a, h                     ; Si el score es de 9753 nos quedamos con el 97
            and #0b00001111             ; Si en A hay un 97 nos quedamos con el 7
            or a
            jr z, score_centenas_is_0           
            ;;;@(score[centenas] != 0)
                ;Restamos una centena al score
                ld bc, #0x0100
                call tools_math_bcdsub
                ld (score), hl
                ;Sumamos una centena al total
                ld bc, #0x0100
                ld hl, (score_total)
                call tools_math_bcdadd

                ld (score_total), hl
                jr end_if_score_centenas
            ;;;
            score_centenas_is_0:
            ;;;@(score[centenas] == 0)
                ld hl, #man_level_sumary_update_millares
                ld (function_to_update_summary), hl
            ;;;
        end_if_score_centenas:
        ;;;}
    ret
;/////////////////

;MAN_LEVEL_SUMARY_UPDATE_MILLARES
    man_level_sumary_update_millares:
        ;;;if(score[millares] != 0){
            ld hl, (score)
            ld a, h                     ; Si el score es de 9753 nos quedamos con el 97
            and #0b11110000             ; Si en A hay un 97 nos quedamos con el 9
            or a
            jr z, score_millares_is_0           
            ;;;@(score[millares] != 0)
                ;Restamos un millar al score
                ld bc, #0x1000
                call tools_math_bcdsub
                ld (score), hl
                ;Sumamos un millar al total
                ld bc, #0x1000
                ld hl, (score_total)
                call tools_math_bcdadd

                ld (score_total), hl
                jr end_if_score_millares
            ;;;
            score_millares_is_0:
            ;;;@(score[millares] == 0)
                ld hl, #man_level_sumary_update_end
                ld (game_state), hl
 
                ld hl, #man_level_sumary_update_unidades
                ld (function_to_update_summary), hl

                ld iy, #level_next_label
                ld c, #LEVEL_NEXT_LABEL_X 
                ld b, #LEVEL_NEXT_LABEL_Y
                call drawString
            ;;;
        end_if_score_millares:
        ;;;}
    ret
;/////////////////

;MAN_LEVEL_SUMARY_UPDATE_END
    man_level_sumary_update_end::

        ;;;if(is_key_pressed && key_pressed = key_space){

            ld a, (_cpct_akp_songLoopTimes)           ;/ guardamos en a el número de loops que lleva la canción
            cp #1                                     ;|
            jr nz, not_end_loop                       ;|y si no es 1 (empieza en 0, con lo que cuando da una vuelta pasa a 1), continúa su ejecución normal
            ld hl, #cpct_akp_stop_asm                 ;|si es 1, para la música
            ld (function_ir_handler), hl              ;\
            not_end_loop:
            call cpct_scanKeyboard_asm

            call cpct_isAnyKeyPressed_asm
            ret z

            ld hl, #Key_Space
            call cpct_isKeyPressed_asm
            ret z
            ;;;@(is_key_pressed && key_pressed = key_space)
                ld hl, #prepare_next_level
                ld (game_state), hl 
            ;;;
        end_if_level_space_pressed:
        ;;;}
        call cpct_waitVSYNC_asm
    ret
;/////////////////

;PREPARE_NEXT_LEVEL
    prepare_next_level::
        ;Pasamos al siguiente nivel
        
        ld hl, #levels_order_step
        inc (hl)
        inc (hl)

        ;;;if(level_ordes_step != null){
            ld hl, (levels_order_step)
            ld a, (hl)
            or a
            jr nz, next_level_exists
            inc hl
            ld a, (hl)
            or a
            jr nz, next_level_exists

            jr next_level_not_exists

            next_level_exists:
            ;;;(level_ordes_step != null)
                ;Pasamos a la pantalla de siguiente nivel
                ld hl, #levelLabelScreenInit
                ld (game_state), hl
                ld hl, #cpct_akp_stop_asm
                ld (function_ir_handler), hl
                ld hl, #music_order
                inc (hl)
                inc (hl)
     

                ld hl, #level_labels_step   ;/
                inc (hl)                    ;| Incrementa el contador de labels para que se muestre el adecuado en el siguiente nivel
                inc (hl)                    ;\

                jr end_if_next_level_exists
            ;;;
            next_level_not_exists:
            ;;;(level_ordes_step == null)
                ;Pasamos a la pantalla de victoria
                ld hl, #victoryScreenInit
                ld (game_state), hl
            ;;;
        end_if_next_level_exists:
        ;;;}

        ;Seteamos la logica del update
        ld hl, #man_level_read 
        ld (f_logic_level), hl
        
    ret
;/////////////////

;LEVELLABELSCREENINIT
    levelLabelScreenInit::
        call sys_render_cleanScreenBlack
        ld l, #char_color_white         ;Color de letra
        ld h, #char_color_black         ;Color de fondo
        call cpct_setDrawCharM0_asm
        cpctm_setBorder_asm HW_BLACK

        ld hl, (level_labels_step)
        ld e, (hl)
        inc hl
        ld d, (hl)
        push de
        pop iy
        ld b, #LEVEL_LABEL_Y
        ld c, #LEVEL_LABEL_X
        call drawString
        
        
        ld hl, (music_order)
        ld e, (hl)
        inc hl
        ld d, (hl)        
        ;ex de, hl 
        call man_music_Init
        ld hl, #cpct_akp_stop_asm
        ld (function_ir_handler), hl
                

        ld hl, #levelLabelScreenUpdate
        ld (game_state), hl
    ret
;/////////////////

;LEVELLABELSCREENTIMER
    levelLabelScreenUpdate:
        ;;;if(levellabeltimer == 0){
            ld a, (level_label_timer)
            or a
            jr nz, dec_level_label_timer
            ;;;@(levellabeltimer == 0)
                ld a, #LEVEL_LABEL_TIME
                ld (level_label_timer), a

                ld hl, #man_game_init
                ld (game_state), hl
                jr end_if_level_label_timer
            ;;;
            dec_level_label_timer:
            ;;;(levellabeltimer != 0)
                dec a
                ld (level_label_timer), a
            ;;;
        end_if_level_label_timer:
        ;;;}
        call cpct_waitVSYNC_asm
    ret

;/////////////////

;VICTORYSCREENINIT
    victoryScreenInit::
        call sys_render_cleanScreenBlack
        ld l, #char_color_white         ;Color de letra
        ld h, #char_color_black         ;Color de fondo
        call cpct_setDrawCharM0_asm

        ;Pitamos la pantalla
        ld iy, #victory_label
        ld b, #VICTORY_LABEL_Y
        ld c, #VICTORY_LABEL_X
        call drawString

        ld iy, #score_total_label
        ld hl, (score_total)
        ld c, #VICTORY_TOTAL_LABEL_X
        ld b, #VICTORY_TOTAL_LABEL_Y
        call drawScoreLine

        ;Pitamos la pantalla
        ld iy, #level_next_label
        ld b, #VICTORY_SPACE_LABEL_Y
        ld c, #VICTORY_SPACE_LABEL_X
        call drawString


        ;Pintamos la caja del boss triste
        call drawSadCajaBoss

        ;Reseteamos los valores globales
        call man_level_reset

        ld hl, #victoryScreenUpdate
        ld (game_state), hl
    ret

;/////////////////

;VICTORYSCREENUPDATE
    victoryScreenUpdate::
        ;;;if(is_key_pressed && key_pressed = key_space){
            call cpct_scanKeyboard_asm

            call cpct_isAnyKeyPressed_asm
            ret z

            ld hl, #Key_Space
            call cpct_isKeyPressed_asm
            ret z
            ;;;@(is_key_pressed && key_pressed = key_space)
                ld hl, #man_menu_main_init
                ld (game_state), hl 
            ;;;
        ;;;}
    ret

;/////////////////

;MAN_LEVEL_RESET
    ;Reseta todos los valores del levels
    man_level_reset::
        ld hl, #man_level_read 
        ld (f_logic_level), hl

        ld bc, #0x0000
        ld (entities_left_counter), bc
        ld (spawn_timer), bc
        ld (score_total), bc
        ld (score), bc

        ld bc, #0xFFFF
        ld (last_entities_left_counter), bc
        ld (last_score), bc

        ld hl, #level_labels
        ld (level_labels_step), hl

        ld hl, #levels_order
        ld (levels_order_step), hl

        ld hl, #music_labels
        ld (music_order), hl
        ld hl, #cpct_akp_stop_asm
        ld (function_ir_handler), hl
    ret
;/////////////////////////////