;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "cpctelera.h.s"
.include "menu.h.s"
.include "game.h.s"
.include "main.h.s"
.include "sys/render.h.s"
.include "entity.h.s"
.include "sys/generator.h.s"
.include "sys/score.h.s"
.include "man/levels.h.s"
.include "sprites/assets.h.s"
.include "music/music.h.s"
.include "man/int.h.s"


;;STRINGS EN MEMORIA


press_to_play:
    .asciz "Press [SPACE]"

press_to_stop:
    .asciz "Press [ESC]"
press_to_intr:
    .asciz "[C]ontrols"

press_to_easter:
    .asciz "[E]xtreme"

left_control:
    .asciz "O: "

right_control:
    .asciz "P: "

easter:
    .db 0

l_token:
    .db 0

ex_token:
    .db 0


;MAN_MENU_MAIN_INIT
    ; Inicializa el menu
    man_menu_main_init::
        xor a
        ld (easter), a
        ld (extreme_active), a
        ld (l_token), a
        ld (ex_token), a
        
        call sys_render_cleanScreenBlack
        call change_screen_to_show_C000
        call man_level_reset

        ld l, #char_color_white         ;Color de letra
        ld h, #char_color_black         ;Color de fondo
        call cpct_setDrawCharM0_asm

        ld de, #0xC000
        ld c, #LOGO_X
        ld b, #LOGO_Y
        call cpct_getScreenPtr_asm

        ld de, #_sp_logo
        ex de, hl
        ld c, #SP_LOGO_W
        ld b, #SP_LOGO_H
        call cpct_drawSprite_asm 

        ld iy, #press_to_intr
        ld c, #CONTROLS_X 
        ld b, #CONTROLS_Y
        call drawString

        ld iy, #press_to_play
        ld c, #PLAY_X 
        ld b, #PLAY_Y
        call drawString
        
        call man_music_menu



        ld iy, #press_to_easter
        ld c, #EASTER_X 
        ld b, #EASTER_Y
        call drawString 
    
        ; //TODO CAMBIAR EL GAME_STATE a man_menu_main
        ld hl, #man_menu_main
        ld (game_state), hl
        ret
;/////////////////////

;MAN_MENU_MAIN
    ; Logica del menu principal
    man_menu_main::
        ;; Estaneamos el teclado para actuar en consecuencia    
        call cpct_scanKeyboard_asm
        call cpct_isAnyKeyPressed_asm


        ld hl, #cpct_akp_musicPlay_asm
        ld (function_ir_handler), hl
        call man_int_init

        jr z, end_menu_main

        ld hl, #Key_Space
        call cpct_isKeyPressed_asm
        jr z, not_space
        ;;if(isKeyPressed('space')){
         ;; //TODO SPACE PRESSED
         ld hl, #levelLabelScreenInit
         ld (game_state), hl


        jr end_menu_main
        ; else {
         not_space:
            ;;if(isKeyPressed('C')) {
                ld hl, #Key_C
                call cpct_isKeyPressed_asm
                jr z, end_menu_main ;;FALSE

            ;; TRUE
                ld hl, #man_menu_controls_init
                ld (game_state), hl
                jr end_menu_main
            ;; // TODO C PRESSED

        

        end_menu_main:

        ;;;if(isKeyPressed('L')){
            ld hl, #Key_L
            call cpct_isKeyPressed_asm
            jr z, l_is_not_pressed
            ;;;@(isKeyPressed('L'))
                ;;;if(easter == 1 && l_token == 1){
                    ld a, (l_token)
                    or a
                    jr nz, end_easter_inactive
                    ld a, (easter)
                    or a
                    jr z, easter_is_inactive
                    ;;;@(easter == 1)
                        xor a
                        ld (easter), a
                        cpctm_setBorder_asm HW_BLACK
                        jr end_easter_inactive
                    ;;;
                    easter_is_inactive:
                    ;;;@(easter == 0){
                        ld a, #1
                        ld (easter), a
                        cpctm_setBorder_asm HW_WHITE
                    ;;;
                end_easter_inactive:
                ;;;}
                ld a, #1
                ld (l_token), a
                jr end_if_l_pressed
            ;;;
            l_is_not_pressed:
            ;;;@(!isKeyPressed('L'))
                xor a
                ld (l_token), a
            ;;;
        end_if_l_pressed:
        ;;;}

        ;;;if(isKeyPressed('E')){
            ld hl, #Key_E
            call cpct_isKeyPressed_asm
            jr z, e_is_not_pressed
            ;;;@(isKeyPressed('L'))
                ;;;if(extreme == 1 && l_token == 1){
                    ld a, (ex_token)
                    or a
                    jr nz, end_extreme_inactive
                    ld a, (extreme_active)
                    or a
                    jr z, extreme_is_inactive
                    ;;;@(extreme == 1)
                        xor a
                        ld (extreme_active), a
                        cpctm_setBorder_asm HW_BLACK
                        jr end_extreme_inactive
                    ;;;
                    extreme_is_inactive:
                    ;;;@(extreme == 0){
                        ld a, #1
                        ld (extreme_active), a
                        cpctm_setBorder_asm HW_RED
                    ;;;
                end_extreme_inactive:
                ;;;}
                ld a, #1
                ld (ex_token), a
                jr end_if_e_pressed
            ;;;
            e_is_not_pressed:
            ;;;@(!isKeyPressed('L'))
                xor a
                ld (ex_token), a
            ;;;
        end_if_e_pressed:
        ;;;}
        
        ret
;/////////////////////


;MAN_MENU_CONTROLS_INIT
    ; Inicializa el menu de los controles del jugador
    man_menu_controls_init::
        call sys_render_clean
        ld l, #char_color_background_2         ;Color de letra
        ld h, #char_color_background         ;Color de fondo
        call cpct_setDrawCharM0_asm
        ;//TODO IMPRIMIR EL TEXTO CORRESPONIENTE
        ;; Controles a la derecha
            ;; Memoria de video 0xC000
            ld de, #0xC000
            ld c, #O_X
            ld b, #O_Y
            call cpct_getScreenPtr_asm

            ld iy, #right_control
            call cpct_drawStringM0_asm

            ;; Memoria del segundo buffer 0x8000
            ld de, #0x8000
            ld c, #O_X
            ld b, #O_Y
            call cpct_getScreenPtr_asm

            ld iy, #right_control
            call cpct_drawStringM0_asm
        ;; ///
        
        ;; Controles a la izquierda
            ;; Memoria de video 0xC000
            ld de, #0xC000
            ld c, #P_X
            ld b, #P_Y
            call cpct_getScreenPtr_asm

            ld iy, #left_control
            call cpct_drawStringM0_asm

            ;; Memoria del segundo buffer 0x8000
            ld de, #0x8000
            ld c, #P_X
            ld b, #P_Y
            call cpct_getScreenPtr_asm

            ld iy, #left_control
            call cpct_drawStringM0_asm
        ;; ///


        ;; Volver al menu inicial
            ;; Memoria de video 0xC000
            ld de, #0xC000
            ld c, #15
            ld b, #173
            call cpct_getScreenPtr_asm

            ld iy, #press_to_stop
            call cpct_drawStringM0_asm

            ;; Memoria del segundo buffer 0x8000
            ld de, #0x8000
            ld c, #15
            ld b, #173
            call cpct_getScreenPtr_asm

            ld iy, #press_to_stop
            call cpct_drawStringM0_asm
        ;; ///

        ;//SETTEAR TODO LO NECESARIO PARA PONER LAS ENTIDADES A CORRER
        call man_entity_init
        
        
        ld a, #0x00
        ld b, #45
        ld c, #0 
        call sys_generator_custom_player

        ld a, #0x01
        ld b, #47
        ld c, #85
        call sys_generator_custom_player
        
        ;//CAMBIAR EL GAME_STATE A MAN_MENU_CONTROLS
        ld hl, #man_menu_controls
        ld (game_state), hl
        ret
;/////////////////////

;MAN_MENU_CONTROLS
    man_menu_controls::
        ; // TODO ANIMAR A UN 2 JUGADORES Y UNAS VIDAS
            call man_animation_update
            call sys_render_update_controls
            call cpct_waitVSYNC_asm
        ;; ////
        ;; Estaneamos el teclado para actuar en consecuencia    
        call cpct_scanKeyboard_asm
        call cpct_isAnyKeyPressed_asm

        jr z, end_menu_controls

        ld hl, #Key_Space
        call cpct_isKeyPressed_asm
        jr z, end_menu_controls
        ;;if(isKeyPressed('space')){
         ;; //TODO SPACE PRESSED
         ld hl, #levelLabelScreenInit
         ld (game_state), hl

        end_menu_controls:
        ret
;/////////////////////