;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "cpctelera.h.s"
.include "ai.h.s"
.include "man/entity.h.s"
.include "render.h.s"
;.include "man/animations.h.s"
.include "sprites/assets.h.s"
.include "man/int.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;MEMORIA;;;;;;;;;;;;;;;;;;;;;;;;;;;
  blink_timer:
    .db 1         ;Valor 1 inicialmente para que el efecto de parpadeo se produzca nada mas te golpean

  blinks_left:
    .db BLINKS   

  blink_status:
    .db 0      
;///////////////////////////////////////////////////////////


;;;;;;;;;;;;;;;;;;;;;;;;;;FUNCIONES;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;FIGURAS;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;NEGRA;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;;;La dividimos en dos funciones, una que no hace nada excepto comprobar que llega a la posicion del jugador - 5 y la segunda para atacar
    ;;;Función move
     ;;;La entidad comprueba que la entidad llega a una posición y cambia su velocidad a 0
    sys_ia_negra_move::
      ld a, ent_type(iy)
      and #ENT_TYPE_ORIENTATION 
      or a 
      jr z, move_negra_right
      ;;;Se mueve a la izquierda
        ld a, ent_x(iy)
        cp #(ENT_PLAYER_RELATIVE_X +SP_NEGRA_W - 2) 
        ret nz
        jr end_move_negra
      ;;;Se mueve a la derecha
      move_negra_right:
        ld a, ent_x(iy)
        cp #(ENT_PLAYER_X - SP_NEGRA_W + 1)
        ret nz
        jr end_move_negra
      ;;;Una vez se ha movido al sitio deseado
      end_move_negra:
        ld b,  #ENT_TYPE_ATACKING 
        call man_entity_add_type
      ret
    ;;;Función attack;;;;;;;;;;;;;;;
     ;;;Función de ataque que se encarga de golpear al enemigo
      sys_ia_negra_attack::
        ret
  
  ;;;redonda;;;;;;;;;;;;;;;;;;;;;;;;
   ;;;El comportamiento del enemigo redonda es similar al de la negra solo que se mueve en una altura
    ;;;Función move
     ;;;La entidad comprueba que la entidad llega a una posición y cambia su velocidad a 0
    sys_ia_redonda_move::
      call sys_ia_update_height      ;;;;Línea 456
      ld a, ent_type(iy)
      and #ENT_TYPE_ORIENTATION 
      or a 
      jr z, move_redonda_right
      ;;;Se mueve a la izquierda
        ld a, ent_x(iy)
        cp #(ENT_PLAYER_RELATIVE_X +SP_REDONDA_W - 4)   
        ret nz
        jr end_move_redonda
      ;;;Se mueve a la derecha
      move_redonda_right:
        ld a, ent_x(iy)
        cp #(ENT_PLAYER_X - SP_REDONDA_W +1 )
        ret nz
        jr end_move_redonda
      ;;;Una vez se ha movido al sitio deseado
      end_move_redonda:
        ld b, #ENT_TYPE_ATACKING
        call man_entity_add_type
      ret
  ;;;SEMIFUSA;;;;;;;;;;;;;;;;;;;;;;;
   ;;;Dividida en cuatro funciones: move, pausa, embestida y final
   ;;;Función move
     ;;;La entidad comprueba que la entidad llega a una posición y cambia su velocidad a 0
     sys_ia_semifusa_move::

      ;;;Comprobamos si está a la izquierda o a la derecha
      ld a, ent_type(iy)
      and #ENT_TYPE_ORIENTATION 
      or a 
      jr z, move_semifusa_right
       ;if(ent_x <= 45){ent_vx = 0}
        ;/////////// Si está en la derecha
        ld a, ent_x(iy)
        cp #AI_SEMIFUSA_RIGHT
        ret nz
        jr end_move_semifusa
       ;/////////// Si está en la izquierda
      move_semifusa_right:
        ld a, ent_x(iy)
        cp #AI_SEMIFUSA_LEFT
        ret nz
        jr end_move_semifusa
      ;;;Una vez se ha movido al sitio deseado
      end_move_semifusa:
        ld a, #AI_PAUSE_SEMIFUSA                          ;;;Activa el contador de la semifusa
        ld ent_contador(iy), a
        ld a , #(ENT_TYPE_PHYSICS | ENT_TYPE_ANIMATION)   ;;;Carga en a la maścara de físicas y animación
        xor #0xFF                                         ;;;Hacemos un XOR con FF
        and ent_type(iy)                                  ;;;Y un AND para poder desacrivar la máscara de físicas de la entidad y no cambiar su velocidad y la de animación para que el sprite se pare
        ld ent_type(iy), a
        ld hl, #sys_ia_semifusa_pause
        ld ent_behavior_mayor(iy), l
        ld ent_behavior_menor(iy), h
      ret

   ;;;Función Pausa
    ;;;Pausa la entidad durante x tiempo (0.6 s?)
    sys_ia_semifusa_pause::
      ld a, ent_contador(iy)
      or a
      jr nz, dec_counter_semifusa
      ld hl, #sys_ia_semifusa_rush
      ld ent_behavior_mayor(iy), l
      ld ent_behavior_menor(iy), h
      ld a, ent_type(iy)                                                    ;;;Carga en a la máscara
      or #(ENT_TYPE_PHYSICS | ENT_TYPE_ANIMATION)                           ;;;Hace un OR con las físicas
      ld ent_type(iy), a                                                    ;;;Y lo cargamos para volver a activar las físicas en la máscara
      ld a, ent_vx(iy)
      add a, a
      ld ent_vx(iy), a
      jr end_pause_semifusa 
      dec_counter_semifusa:
         dec a
         ld ent_contador(iy), a 
      end_pause_semifusa:
         ret
   ;;;Función Rush
    ;;;Cuando pasa el tiempo establecido, cambia la velocidad (multiplicar por x)
    sys_ia_semifusa_rush::
      ld a, ent_type(iy)
      and #ENT_TYPE_ORIENTATION 
      or a 
      jr z, rush_semifusa_right
        ld a, #(AI_MARGIN_RIGHT -2)   ;; /
        cp ent_x(iy)              ;; | enemy_x <= AI_MARGEN_RIGHT
        ret c                     ;; \ else

        ; if(enemy_x <= AI_MARGEN_RIGHT) {
        jr end_semifusa
        ; }
      rush_semifusa_right:
        ld a, ent_x(iy)   ;; /
        cp #AI_MARGIN_SEMIFUSA_LEFT               ;; | enemy_x <= AI_MARGEN_RIGHT
        ret c                                     ;; \ else

        ; if(enemy_x <= AI_MARGEN_RIGHT) {
        jr end_semifusa
      end_semifusa:
        ld b, #ENT_TYPE_ATACKING
        call man_entity_add_type
        ret
  ;;;BLANCA;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;;Función init;;;;;;;;;;;;;;;;;;
    ;;Función que inicia un contador para que veas aparecer al enemigo antes de que vaya bajo tierra
    sys_ia_blanca_init::
      ld a, ent_type(iy)
      and #ENT_TYPE_ORIENTATION 
      or a 
      jr z, init_blanca_right
       ;;Si está en la derecha
        ld a, ent_x(iy)
        cp #AI_MARGIN_RIGHT_INIT
        ret nz
        ld de, #animation_blanca_leftdig
        jr end_init_blanca
      ;;Si está en la izq
      init_blanca_right:
        ld a, ent_x(iy)
        cp #AI_MARGIN_LEFT_INIT
        ret nz
        ld de, #animation_blanca_rightdig
        jr end_init_blanca
      ;;Cuando está en el sitio deseado
      end_init_blanca:
        ;ld a, #AI_PAUSE_BLANCA                            ;;;Activa el contador de la blanca
        ld a , #(ENT_TYPE_PHYSICS | ENT_TYPE_COLISION)                        ;;;Carga en a la maścara de físicas, no queremos que su velocidad esté activa 
        xor #0xFF                                         ;;;Hacemos un XOR con FF
        and ent_type(iy)                                  ;;;Y un AND para poder desacrivar la máscara de físicas de la entidad y no cambiar su velocidad y 
        ld ent_type(iy), a
        ld hl, #sys_ia_blanca_dig
        call sys_ia_blanca_pause    
      ;;Faltaría cambiar la animación del topo(?)
      ret
   ;;Función pausa;;;;;;;;;;;;;;;;;;;
    ;;Función que pausa y cambia estado y animación
    sys_ia_blanca_pause:
        ld ent_behavior_mayor(iy), l
        ld ent_behavior_menor(iy), h
        ld ent_animation_mayor(iy), e
        ld ent_animation_menor(iy), d
        ld a, #AI_PAUSE_BLANCA                             ;;;Activa el contador de la blanca
        ld ent_contador(iy), a
        jr end_pause_blanca 
      end_pause_blanca:
         ret
   ;;Función dig;;;;;;;;;;;;;;;;;;
    ;;Estado de la IA en el que hace la animación de meterse bajo tierra y pasa al estado de moverse
    sys_ia_blanca_dig::
      ld a, ent_contador(iy)
      or a
      jr nz, dec_counter_blanca_dig
        ld hl, #sys_ia_blanca_move
        ld ent_behavior_mayor(iy), l
        ld ent_behavior_menor(iy), h
        ld a, ent_type(iy)                                                ;;;Carga en a la máscara
        or #(ENT_TYPE_PHYSICS)                                            ;;;Hace un OR con las físicas
        ld ent_type(iy), a                                                ;;;Y lo cargamos para volver a activar las físicas en la máscara
        jr end_dig_blanca 
      dec_counter_blanca_dig:
         dec a
         ld ent_contador(iy), a 
      end_dig_blanca:
         ret
         
   ;;Función move;;;;;;;;;;;;;;;;;;
    ;;El topo se mueve bajo tierra
    sys_ia_blanca_move::
      ld a, ent_type(iy)
      and #ENT_TYPE_ORIENTATION 
      or a 
      jr z, move_blanca_right
        ld a, ent_x(iy)
        cp #AI_MARGIN_BLANCA_RIGHT
        ret nz
        ld de, #animation_blanca_leftdigout
        jr end_move_blanca
       ;/////////// Si está en la izquierda
      move_blanca_right:
        ld a, ent_x(iy)
        cp #AI_MARGIN_BLANCA_LEFT
        ret nz
        ld de, #animation_blanca_rightdigout
        jr end_move_blanca
      ;;Una vez se ha movido al sitio deseado
      end_move_blanca:
        ;ld a, #AI_PAUSE_BLANCA                            ;;;Activa el contador de la semifusa

        ld a , #(ENT_TYPE_PHYSICS)                        ;;;Carga en a la maścara de físicas 
        xor #0xFF                                         ;;;Hacemos un XOR con FF
        and ent_type(iy)                                  ;;;Y un AND para poder desacrivar la máscara de físicas de la entidad y no cambiar su velocidad 
        ld ent_type(iy), a
        ld hl, #sys_ia_blanca_undig
        call sys_ia_blanca_pause
      ret
   ;;Función undig;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;La blanca sale del agujero y cambia al estado atacar
    sys_ia_blanca_undig::
      ld a, ent_contador(iy)
      or a
      jr nz, dec_counter_blanca_undig
        ld hl, #sys_ia_blanca_attack
        ld ent_behavior_mayor(iy), l
        ld ent_behavior_menor(iy), h
        ld a, ent_type(iy)                                                ;;;Carga en a la máscara
        or #(ENT_TYPE_PHYSICS | ENT_TYPE_COLISION)   ;;;Hace un OR con las físicas
        ld ent_type(iy), a                                                ;;;Y lo cargamos para volver a activar las físicas en la máscara
        jr end_undig_blanca 
      dec_counter_blanca_undig:
         dec a
         ld ent_contador(iy), a 
      end_undig_blanca:
         ret
   ;;Función atacar;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;;La blanca ha terminado de salir y a continuación, se dispone a atacar yendo hacia el pj
    sys_ia_blanca_attack::
      ;;;;habilitar is attacking?
      ld a, ent_type(iy)
      and #ENT_TYPE_ORIENTATION 
      or a 
      jr z, attack_blanca_right
       ;;;Si está en la derecha
        ld a, ent_x(iy)
        cp #(ENT_ATACK_X_RIGHT -1)
        ret nz
        jr attack_end_blanca
      ;;;Si está en la izquierda
      attack_blanca_right:
        ld a, ent_x(iy)
        cp #(ENT_PLAYER_X - SP_BLANCA_W + 1 )
        ret nz
        jr attack_end_blanca
      attack_end_blanca:
        ld b, #ENT_TYPE_ATACKING
        call man_entity_add_type

      ret
    
 ;;;UPDATE;;;;;;;;;;;;;;;;;;;;;;;;;;

  
  ;;;FUNCIÓN UPDATE ONE ENTITY;;;;;;;;;;;;;;;;;;;;;;
   ;;;Actualiza cada entidad que tiene IA (Inversión de control)
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   sys_ai_update_one_entity::
      ld hl, #continuar
      push hl
      ld l, ent_behavior_mayor(iy)
      ld h, ent_behavior_menor(iy)
      jp (hl)
      continuar:
    ret
     

  ;;;FUNCIÓN UPDATE ALL;;;;;;;;
   ;;;Se le pasa la máscara para que actualice todas las entidades con ia;;;;;;;;;;
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   sys_ai_update::
      ld a,   #ENT_TYPE_AI
      ld hl,  #sys_ai_update_one_entity
      call man_entity_forall_mask
    ret

 ;;;OTRAS FUNCIONES;;;;;;;;;;;;;;;;;;
  ;;;Función die;;;;;;;;;;;;;;;;;;
     ;;;Lanza su animación de muerte y condena a la entidad;;;;;
      sys_ia_die::
          ld a, ent_contador(iy)
          or a
          jr nz, dec_counter_die
          ; ld a, ent_type(iy)                                        ;;;Carga en a la máscara
          ; or #(ENT_TYPE_CONDEMNED)                                   ;;;Hace un OR con las físicas
          ; ld ent_type(iy), a                                        ;;;Y lo cargamos para volver a activar las físicas en la máscara
          call man_entity_condemn
          jr end_die
        dec_counter_die:
          dec a                       ;; / Decrementamos el contador de la entidad
          ld ent_contador(iy), a      ;; \

          ld a, ent_y(iy)             ;; /
          dec a                       ;; | Decrementamos en 1 la posicion en Y (la entidad sube)
          ld ent_y(iy), a             ;; \
        end_die:
          ret


  ;;;SYS_IA_UPDATE_HEIGHT;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;;;Comprueba el byte de estado para saber si sube (1) o baja (0). Usa el contador para ajustar su posicion
    sys_ia_update_height:
      ld a, ent_ia_status(iy)
      or a
      jr z, _move_down

      _move_up:
        ld a, ent_y(iy)
        cp #AI_MAX_HEIGTH

          ;si el contador llega a 10, cambiar el byte de status. Si no, aumentar el contador hasta 10
          jr nc, _dec_y
          ld ent_ia_status(iy), #0
          jr end_update_height

          _dec_y:
            ld a, ent_y(iy)
            sub #AI_VY
            ld ent_y(iy), a
            jr end_update_height
      _move_down:
        ld a, ent_y(iy)
        cp #AI_MIN_HEIGTH

          ;si el contador llega a 0, cambiar el byte de status. Si no, disminuir el contador hasta 0
          jr c, _inc_y
          ld ent_ia_status(iy), #1
          jr end_update_height

            _inc_y:
              ld a, ent_y(iy)
              add #AI_VY
              ld ent_y(iy), a
      end_update_height:
        ret

  ;;SYS_IA_THRESHOLD_COUNT
    ;Actualiza el contador del tiempo que tiene que estar el aviso activo
    ;Inputs:    IY <- puntero a la entidad con la que se va a trabajar (se presupone que siempre va a ser la entidad de aviso de umbral)
    ;Destrois:  A, B
    sys_ia_threshold_count::
      ;call man_sfx_play
      ld a, ent_y(iy)     ;; 
      dec a               ;; Efecto de moverse hacia arriba
      
      ld ent_y(iy), a     ;; 
      ld a, ent_contador(iy)
      dec a                   ;; / Decrementamos el contador de la entidad
      ld ent_contador(iy), a  ;; \
      or a

      ;if (threshold['ent_contador'] != 0) end
       jr nz, end_threshold_count
      ;else
       ld b, #(ENT_TYPE_RENDER | ENT_TYPE_AI)
       call man_entity_remove_type
       call sys_render_delete
      ;//

      end_threshold_count: 
      
      ret
  ;////////////////////

;SYS_IA_PLAYERBLINK
  sys_ia_playerblink::
    ;;;if(blink_timer == 0){
      ld a, (blink_timer)
      or a
      jr nz, blink_timer_not_0
      ;;;@(blink_timer == 0)
        ;;;if(blink_status == 0){
          ld a, (blink_status)
          or a
          jr nz, blink_status_not_0
          ;;;@(blink_status == 0)
              ;Cambiamos blink status a 1
              inc a
              ld (blink_status), a
              ;Cambiamos el color del borde a rojo
              cpctm_setBorder_asm HW_RED

              jr end_if_blink_status
          ;;;
          blink_status_not_0:
          ;;;@(blink_status == 1)
              ;Cambiamos blink status a 0
              xor a
              ld (blink_status), a
              
              ;Cambiamos el color del borde a negro
              cpctm_setBorder_asm HW_BLACK
          ;;;
        end_if_blink_status:
        ;;;}
        
        ld a, (blinks_left)       ;/
        dec a                     ;|Acabamos de hacer un parpadeo así que disminuimos la cantidad de parpadeos pendientes
        ld (blinks_left), a       ;\

        ld a, #BLINK_TIME         ;/
        ld (blink_timer), a       ;\ Reseteamos el timer

        jr end_if_blink_timer
      ;;;
      blink_timer_not_0:
      ;;;@(blink_timer != 0)
        dec a
        ld (blink_timer), a
      ;;;
      end_if_blink_timer:
    ;;;}

    ;;;if(blinks_left == 0){
      ld a, (blinks_left)
      or a
      ret nz
      ;;;@(blinks_left == 0)
        ld a, #BLINKS
        ld (blinks_left), a
        ld a, #1              ;Seteamos el timer a 1 para que se produzca el efecto nada mas ser golpeado
        ld (blink_timer), a
        ld ent_behavior_mayor(iy), #<sys_ia_playerDoNothing
        ld ent_behavior_menor(iy), #>sys_ia_playerDoNothing
      ;;;
    ;;;}
  ret
;////////////////////

;SYS_IA_PLAYERDONOTHING
  sys_ia_playerDoNothing:
  ret
;////////////////////