;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "cpctelera.h.s"
.include "physics.h.s"
.include "../man/entity.h.s"


;;; ///////////////////////////////////////////
;;; MEMORY
    physics_timer:
        .db PHYSICS_TIMER
;;; ///////////////////////////////////////////


;SYS_PHYSICS_INIT
    ;Inicializa la entidad de fisicas
    sys_physics_init::
        ld a, #PHYSICS_TIMER
        ld (physics_timer), a
        ret

;SYS_PHYSICS_UPDATE_ONE_ENTITY_LEFT
    ;Desplaza una entidad restandole a su posicion su velocidad
    ;Destrois:    
    sys_physics_update_one_entity_left::
        ld a, ent_x(iy)
        sub a, ent_vx(iy)
        ld ent_x(iy), a
    ret
;/////////////////

;SYS_PHYSICS_UPDATE_ONE_ENTITY_RIGHT
    ;Desplaza una entidad sumandole a su posicion su velocidad
    ;Destrois:    
    sys_physics_update_one_entity_right:
        ld a, ent_x(iy)
        add a, ent_vx(iy)
        ld ent_x(iy), a
    ret
;/////////////////


;SYS_PHYSICS_UPDATE
    ;Actualiza la posicion de todas las entidades
    ;Destrois:    
    sys_physics_update::
        ;;;if(physics_timer == 0){
            ld a, (physics_timer)
            or a
            jr nz, decrementar_physics_timer
            ;;;@(physics_timer == 0)
                ;;Movemos todas las entidades que van hacia la izquierda
                ld a, #(ENT_TYPE_PHYSICS | ENT_TYPE_ORIENTATION) 
                ld hl, #sys_physics_update_one_entity_left
                call man_entity_forall_mask

                ;;Movemos todas las entidades que van hacia la derecha
                ld a, #(ENT_TYPE_PHYSICS) 
                ld d, #(ENT_TYPE_ORIENTATION)
                ld hl, #sys_physics_update_one_entity_right
                call man_entity_forall_precise

                ;;Reseteamos el timer
                ld a, #PHYSICS_TIMER
                ld (physics_timer), a
                
                jr end_if_physics_timer
            ;;;
            decrementar_physics_timer:
            ;;;@(physics_timer != 0)
                dec a
                ld (physics_timer), a
            ;;;
        end_if_physics_timer:
        ;;;}    
    ret
;/////////////////



