.include "man/animations.h.s"
.include "sprites/assets.h.s"

;;; ///////////////////////////////////////////
;;; Symbols
    background_color_2  = 0xC0
    first_buffer        = 0xC000
    second_buffer       = 0x8000

    ;Para los bordes de los laterales
        border_width_bytes  = 7
        screen_width_bytes  = 80
        screen_height       = 200
        border_y            = 0
        border_left_x       = 0
        border_right_x      = screen_width_bytes - border_width_bytes
        black_color        = 0xF3      ;; NEGRO

    ;Para los fragmentos de los bordes (los que vamos a pintar en cada vuelta)
        fragment_relative_y =   100
        fragment_height     =   40
        fragment_y          =   fragment_relative_y - fragment_height

    ;Para el dibujado de bytes
        ASCII_VALUE             = 48
        CHARACTER_BYTES_W       = 4
        CHARACTER_BYTES_H       = 8

    ENTITIES_LEFT_LABEL_X = 55 
    ENTITIES_LEFT_LABEL_Y = 20 - SP_ENEMIES_H + 8 
    ENTITIES_LEFT_X_X = ENTITIES_LEFT_LABEL_X + SP_ENEMIES_W + 1
    ENTITIES_LEFT_X_Y = 20
    ENTITIES_LEFT_COUNTER_X = ENTITIES_LEFT_X_X + CHARACTER_BYTES_W 
    ENTITIES_LEFT_COUNTER_Y = 20

    SCORE_Y = 20
    SCORE_X = 10

    ;Para el dibujado de columnas
        COLUMN_1_X      = 3
        COLUMN_1_Y      = 44

        COLUMN_2_X      = COLUMN_1_X + COLUMN_BASE_W + 8
        COLUMN_2_Y      = COLUMN_1_Y

        COLUMN_3_X      = COLUMN_2_X + COLUMN_BASE_W + 18
        COLUMN_3_Y      = COLUMN_1_Y

        COLUMN_4_X      = COLUMN_3_X + COLUMN_BASE_W + 8
        COLUMN_4_Y      = COLUMN_1_Y

        COLUMN_CENTER_W = 6
        COLUMN_CENTER_H = 72

        COLUMN_BASE_W   = 10
        COLUMN_BASE_H   = 9

        COLUMN_SEMIBASE_W   = 8
        COLUMN_SEMIBASE_H   = 3

        COLUMN_BRIGHT_W     = 1
        COLUMN_BRIGHT_H     = COLUMN_CENTER_H
        COLUMN_BRIGHT_COLOR = 0x40
        COLUMN_BRIGHT_DISPLACEMENT = 4

        COLUMN_DISPLACEMENT = 1
    
    ;Para el dibujado de velas
        VELA_X_DISPLACEMENTS  = 4 
        VELA_Y_DISPLACEMENTS  = 20

        VELA_1_X            = COLUMN_1_X + VELA_X_DISPLACEMENTS 
        VELA_1_Y            = COLUMN_1_Y + VELA_Y_DISPLACEMENTS

        VELA_2_X            = COLUMN_2_X + VELA_X_DISPLACEMENTS 
        VELA_2_Y            = COLUMN_2_Y + VELA_Y_DISPLACEMENTS

        VELA_3_X            = COLUMN_3_X + VELA_X_DISPLACEMENTS 
        VELA_3_Y            = COLUMN_3_Y + VELA_Y_DISPLACEMENTS

        VELA_4_X            = COLUMN_4_X + VELA_X_DISPLACEMENTS 
        VELA_4_Y            = COLUMN_4_Y + VELA_Y_DISPLACEMENTS

    ;Para el dibujado de ventanas
        VENTANA_X_DISPLACEMENTS = 3
        VENTANA_Y_DISPLACEMENTS = 20

        VENTANA_BASE_DISPLACEMENTS = 1

        DECT_VENTANA_X_DISPLACEMENTS = 3

        VENTANA_BASE_W  = SP_VENTANA_W-2 ;Le resto 2 porque el ancho de la ventana es 2 mas de lo que debería para poder cuadrarla
        VENTANA_BASE_H  = 5
        
        VENTANA_1_X     =  COLUMN_1_X + COLUMN_CENTER_W + VENTANA_X_DISPLACEMENTS 
        VENTANA_1_Y     =  COLUMN_1_Y + VENTANA_Y_DISPLACEMENTS 

        VENTANA_2_X     =  COLUMN_3_X + COLUMN_CENTER_W + VENTANA_X_DISPLACEMENTS 
        VENTANA_2_Y     =  COLUMN_3_Y + VENTANA_Y_DISPLACEMENTS 
    ;Para el dibujado del suelo
        SUELO_X = 0
        SUELO_Y = 140
        SUELO_H = 4
        SUELO_W = 80

        SUELO_BASE_Y = SUELO_Y + 30
        SUELO_BASE_H = 200 - SUELO_BASE_Y ;Hasta el final de la pantalla
    ;Para el dibujado de la caja del boss
        CAJA_X_DISPLACEMENT = 1
        CAJA_Y_DISPLACEMENT = 53
        CAJA_X = COLUMN_2_X + COLUMN_BASE_W + CAJA_X_DISPLACEMENT
        CAJA_Y = SUELO_Y - CAJA_H - CAJA_Y_DISPLACEMENT
        CAJA_W = 16
        CAJA_H = 45
        dark_blue_color = 0x3C
        white_color     = 0xFF

        FRANJA_X_DISPLACEMENT = 1
        FRANJA_Y_DISPLACEMENT = 2
        FRANJA_W = 2
        FRANJA_H = CAJA_H - 4

        EYE_LEFT_X = CAJA_X + CAJA_X_DISPLACEMENT * 2 + FRANJA_W
        EYE_RIGHT_X = CAJA_X + CAJA_X_DISPLACEMENT * 4 + FRANJA_W * 3
        EYE_Y = CAJA_Y + 9

        MOUTH_X = EYE_LEFT_X
        MOUTH_Y = EYE_Y + 11

        HAND_LEFT_X = EYE_LEFT_X - (FRANJA_W/2) - 1
        HAND_RIGHT_X = (EYE_RIGHT_X + (FRANJA_W/2)) - 1
        HAND_Y = MOUTH_Y + 10
    
    ;Para el dibujado de las cadenas
        rotated_chain_color = 0x14 ;Probar con 30 si no funciona
        ROTATED_CHAIN_W = 1
        ROTATED_CHAIN_H = 6
        CHAIN_LEFT_X = EYE_LEFT_X - 1
        CHAIN_RIGHT_X = EYE_RIGHT_X
        CHAIN_Y = 0

    ;Puerta
        PUERTA_W = 6
        PUERTA_H = SUELO_BASE_Y - PUERTA_Y
        PUERTA_LEFT_X = 0
        PUERTA_RIGHT_X = 80 - PUERTA_W 
        PUERTA_Y = SUELO_Y - 40
        color_red = 0x0C

        POMO_W = 1
        POMO_H = 4
        POMO_LEFT_X = PUERTA_LEFT_X + 3
        POMO_RIGHT_X = PUERTA_RIGHT_X + 2
        POMO_Y = PUERTA_Y + 31

    ;Para le dibujado de caracteres
        char_color_black = 12
        char_color_white = 14
        char_color_red = 4
        char_color_brighblue = 8
        char_color_background = 0
        char_color_background_2 = 1 
;;; ///////////////////////////////////////////

;;; ///////////////////////////////////////////
;;; Global
    .globl cpct_disableFirmware_asm  
    .globl cpct_setVideoMode_asm
    .globl cpct_setPalette_asm
    .globl cpct_disableFirmware_asm  
    .globl cpct_drawSprite_asm
    .globl cpct_drawSpriteBlended_asm 
    .globl cpct_getScreenPtr_asm 
    .globl cpct_drawSolidBox_asm
    .globl cpct_memset_asm
    .globl cpct_drawCharM0_asm
    .globl cpct_drawStringM0_asm
    .globl cpct_setDrawCharM0_asm

    .globl sys_render_mem_init
    .globl sys_render_init
    .globl sys_render_firstTime
    .globl sys_render_drawSprite
    .globl sys_render_update
    .globl sys_render_update_one_entity
    .globl sys_render_update_controls
    ; .globl sys_draw_box
    ; .globl sys_draw_all_boxes
    ; .globl sys_draw_player_state
    .globl sys_render_delete
    .globl sys_render_clean
    .globl sys_render_update_only_one_entity
    .globl sys_render_draw_one_life
    .globl sys_render_draw_lifes
    .globl sys_render_delete_one_life
    .globl change_screen_to_show_C000
    .globl drawScoreLine
    .globl drawString
    .globl drawScoreSummary
    .globl sys_render_cleanScreenBlack
    .globl last_entities_left_counter
    .globl last_score
    .globl drawSadCajaBoss
;;; ///////////////////////////////////////////