;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;         Copyright (C) 2022,  Panetonent                                             ;;;
;;;                                                                                     ;;;
;;;         This program is free software: you can redistribute it and/or modify        ;;;
;;;         it under the terms of the GNU General Public License as published by        ;;;
;;;         the Free Software Foundation, either version 3 of the License, or           ;;;
;;;         (at your option) any later version.                                         ;;;
;;;                                                                                     ;;;
;;;         This program is distributed in the hope that it will be useful,             ;;;
;;;         but WITHOUT ANY WARRANTY; without even the implied warranty of              ;;;
;;;         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;;;
;;;         GNU General Public License for more details.                                ;;;
;;;                                                                                     ;;;
;;;         You should have received a copy of the GNU General Public License           ;;;
;;;         along with this program.  If not, see <http://www.gnu.org/licenses/>        ;;;
;;;                                                                                     ;;;
;;;                                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.include "cpctelera.h.s"
.include "score.h.s"
.include "render.h.s"
.include "tools/math.h.s"


score::
    .dw #0x0000     ;; Puntuacion inicial

max_lifes::
    .db #0x00

extreme_active::
    .db #0x00

lifes::
    .db #SYS_SCORE_LIFES       ;; Vidas del player

current_life_x::
    .db #0x00

score_total:
    .dw 0x0000 


;SYS_SCORE_INIT
    ; Inicializa la puntuacion del jugador
    ; Inputs:
    ; Outputs:
    ; Destrois:
    sys_score_init::
        ld a, (extreme_active)
        or a

        jr z, normal_lifes
            ld a, #1
            ld (max_lifes), a
            ld a, #SYS_SCORE_LIFE_X_EXTREME_INIT
            ld (current_life_x), a
        jr continue_score_init

        normal_lifes:
            ld a, #SYS_SCORE_LIFES
            ld (max_lifes), a
            ld a, #SYS_SCORE_LIFE_X_INIT
            ld (current_life_x), a

        continue_score_init:
            ld a, (max_lifes)
            ld (lifes), a
            call sys_render_draw_lifes



        ld hl, #0x0000
        ld (score), hl
        ret
;////////////////


;SYS_SCORE_ADD
    ; Añade puntuacion
    ; Inputs:       DE <- puntos para sumar a la puntuacion
    ; Outputs: 
    ; Destrois:     HL
    sys_score_add::
        ; ld hl, (score)
        ; add hl, de
        ; ld (score), hl

        ld hl, (score)
        ld b, d
        ld c, e
        call tools_math_bcdadd

        ld a, (extreme_active)
        or a
        jr z, continue_score_add
            call tools_math_bcdadd

        continue_score_add:
            ld (score), hl

        ret
;////////////////

